# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	0

#define DDR_PSCOUT20  	DDRB
#define PORT_PSCOUT20 	PORTB
#define PIN_PSCOUT20  	PINB
#define PSCOUT20_IDX  	0

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	1

#define DDR_PSCOUT21  	DDRB
#define PORT_PSCOUT21 	PORTB
#define PIN_PSCOUT21  	PINB
#define PSCOUT21_IDX  	1

#define DDR_ADC5  	DDRB
#define PORT_ADC5 	PORTB
#define PIN_ADC5  	PINB
#define ADC5_IDX  	2

#define DDR_INT1  	DDRB
#define PORT_INT1 	PORTB
#define PIN_INT1  	PINB
#define INT1_IDX  	2

#define DDR_AMP0_N  	DDRB
#define PORT_AMP0_N 	PORTB
#define PIN_AMP0_N  	PINB
#define AMP0_N_IDX  	3

#define DDR_AMP0_P  	DDRB
#define PORT_AMP0_P 	PORTB
#define PIN_AMP0_P  	PINB
#define AMP0_P_IDX  	4

#define DDR_ADC6  	DDRB
#define PORT_ADC6 	PORTB
#define PIN_ADC6  	PINB
#define ADC6_IDX  	5

#define DDR_INT2  	DDRB
#define PORT_INT2 	PORTB
#define PIN_INT2  	PINB
#define INT2_IDX  	5

#define DDR_ADC7  	DDRB
#define PORT_ADC7 	PORTB
#define PIN_ADC7  	PINB
#define ADC7_IDX  	6

#define DDR_PSCOUT11  	DDRB
#define PORT_PSCOUT11 	PORTB
#define PIN_PSCOUT11  	PINB
#define PSCOUT11_IDX  	6

#define DDR_ICP1B  	DDRB
#define PORT_ICP1B 	PORTB
#define PIN_ICP1B  	PINB
#define ICP1B_IDX  	6

#define DDR_ADC4  	DDRB
#define PORT_ADC4 	PORTB
#define PIN_ADC4  	PINB
#define ADC4_IDX  	7

#define DDR_PSCOUT01  	DDRB
#define PORT_PSCOUT01 	PORTB
#define PIN_PSCOUT01  	PINB
#define PSCOUT01_IDX  	7

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	7

#define DDR_PSCOUT00  	DDRD
#define PORT_PSCOUT00 	PORTD
#define PIN_PSCOUT00  	PIND
#define PSCOUT00_IDX  	0

#define DDR_XCK  	DDRD
#define PORT_XCK 	PORTD
#define PIN_XCK  	PIND
#define XCK_IDX  	0

#define DDR_SSA  	DDRD
#define PORT_SSA 	PORTD
#define PIN_SSA  	PIND
#define SSA_IDX  	0

#define DDR_PSCIN0  	DDRD
#define PORT_PSCIN0 	PORTD
#define PIN_PSCIN0  	PIND
#define PSCIN0_IDX  	1

#define DDR_CLKO  	DDRD
#define PORT_CLKO 	PORTD
#define PIN_CLKO  	PIND
#define CLKO_IDX  	1

#define DDR_PSCIN2  	DDRD
#define PORT_PSCIN2 	PORTD
#define PIN_PSCIN2  	PIND
#define PSCIN2_IDX  	2

#define DDR_OC1A  	DDRD
#define PORT_OC1A 	PORTD
#define PIN_OC1A  	PIND
#define OC1A_IDX  	2

#define DDR_MISO_A  	DDRD
#define PORT_MISO_A 	PORTD
#define PIN_MISO_A  	PIND
#define MISO_A_IDX  	2

#define DDR_TXD  	DDRD
#define PORT_TXD 	PORTD
#define PIN_TXD  	PIND
#define TXD_IDX  	3

#define DDR_DALI  	DDRD
#define PORT_DALI 	PORTD
#define PIN_DALI  	PIND
#define DALI_IDX  	3

#define DDR_OC0A  	DDRD
#define PORT_OC0A 	PORTD
#define PIN_OC0A  	PIND
#define OC0A_IDX  	3

#define DDR_SS  	DDRD
#define PORT_SS 	PORTD
#define PIN_SS  	PIND
#define SS_IDX  	3

#define DDR_MOSI_A  	DDRD
#define PORT_MOSI_A 	PORTD
#define PIN_MOSI_A  	PIND
#define MOSI_A_IDX  	3

#define DDR_ADC1  	DDRD
#define PORT_ADC1 	PORTD
#define PIN_ADC1  	PIND
#define ADC1_IDX  	4

#define DDR_RXD  	DDRD
#define PORT_RXD 	PORTD
#define PIN_RXD  	PIND
#define RXD_IDX  	4

#define DDR_DALI  	DDRD
#define PORT_DALI 	PORTD
#define PIN_DALI  	PIND
#define DALI_IDX  	4

#define DDR_ICP1  	DDRD
#define PORT_ICP1 	PORTD
#define PIN_ICP1  	PIND
#define ICP1_IDX  	4

#define DDR_SCK_A  	DDRD
#define PORT_SCK_A 	PORTD
#define PIN_SCK_A  	PIND
#define SCK_A_IDX  	4

#define DDR_ADC2  	DDRD
#define PORT_ADC2 	PORTD
#define PIN_ADC2  	PIND
#define ADC2_IDX  	5

#define DDR_ACMP2  	DDRD
#define PORT_ACMP2 	PORTD
#define PIN_ACMP2  	PIND
#define ACMP2_IDX  	5

#define DDR_ADC3  	DDRD
#define PORT_ADC3 	PORTD
#define PIN_ADC3  	PIND
#define ADC3_IDX  	6

#define DDR_ACMPM  	DDRD
#define PORT_ACMPM 	PORTD
#define PIN_ACMPM  	PIND
#define ACMPM_IDX  	6

#define DDR_INT0  	DDRD
#define PORT_INT0 	PORTD
#define PIN_INT0  	PIND
#define INT0_IDX  	6

#define DDR_ACMP0  	DDRD
#define PORT_ACMP0 	PORTD
#define PIN_ACMP0  	PIND
#define ACMP0_IDX  	7

#define DDR_OCD  	DDRE
#define PORT_OCD 	PORTE
#define PIN_OCD  	PINE
#define OCD_IDX  	0

#define DDR_OC0B  	DDRE
#define PORT_OC0B 	PORTE
#define PIN_OC0B  	PINE
#define OC0B_IDX  	1

#define DDR_ADC0  	DDRE
#define PORT_ADC0 	PORTE
#define PIN_ADC0  	PINE
#define ADC0_IDX  	2

