# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_AD0  	DDRA
#define PORT_AD0 	PORTA
#define PIN_AD0  	PINA
#define AD0_IDX  	0

#define DDR_AD1  	DDRA
#define PORT_AD1 	PORTA
#define PIN_AD1  	PINA
#define AD1_IDX  	1

#define DDR_AD2  	DDRA
#define PORT_AD2 	PORTA
#define PIN_AD2  	PINA
#define AD2_IDX  	2

#define DDR_AD3  	DDRA
#define PORT_AD3 	PORTA
#define PIN_AD3  	PINA
#define AD3_IDX  	3

#define DDR_AD4  	DDRA
#define PORT_AD4 	PORTA
#define PIN_AD4  	PINA
#define AD4_IDX  	4

#define DDR_AD5  	DDRA
#define PORT_AD5 	PORTA
#define PIN_AD5  	PINA
#define AD5_IDX  	5

#define DDR_AD6  	DDRA
#define PORT_AD6 	PORTA
#define PIN_AD6  	PINA
#define AD6_IDX  	6

#define DDR_AD7  	DDRA
#define PORT_AD7 	PORTA
#define PIN_AD7  	PINA
#define AD7_IDX  	7

#define DDR_SS  	DDRB
#define PORT_SS 	PORTB
#define PIN_SS  	PINB
#define SS_IDX  	0

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	1

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	2

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	3

#define DDR_OC0  	DDRB
#define PORT_OC0 	PORTB
#define PIN_OC0  	PINB
#define OC0_IDX  	4

#define DDR_OC1A  	DDRB
#define PORT_OC1A 	PORTB
#define PIN_OC1A  	PINB
#define OC1A_IDX  	5

#define DDR_PWM1A  	DDRB
#define PORT_PWM1A 	PORTB
#define PIN_PWM1A  	PINB
#define PWM1A_IDX  	5

#define DDR_OC1B  	DDRB
#define PORT_OC1B 	PORTB
#define PIN_OC1B  	PINB
#define OC1B_IDX  	6

#define DDR_PWM1B  	DDRB
#define PORT_PWM1B 	PORTB
#define PIN_PWM1B  	PINB
#define PWM1B_IDX  	6

#define DDR_OC2  	DDRB
#define PORT_OC2 	PORTB
#define PIN_OC2  	PINB
#define OC2_IDX  	7

#define DDR_OC1C  	DDRB
#define PORT_OC1C 	PORTB
#define PIN_OC1C  	PINB
#define OC1C_IDX  	7

#define DDR_A8  	DDRC
#define PORT_A8 	PORTC
#define PIN_A8  	PINC
#define A8_IDX  	0

#define DDR_A9  	DDRC
#define PORT_A9 	PORTC
#define PIN_A9  	PINC
#define A9_IDX  	1

#define DDR_A10  	DDRC
#define PORT_A10 	PORTC
#define PIN_A10  	PINC
#define A10_IDX  	2

#define DDR_A11  	DDRC
#define PORT_A11 	PORTC
#define PIN_A11  	PINC
#define A11_IDX  	3

#define DDR_A12  	DDRC
#define PORT_A12 	PORTC
#define PIN_A12  	PINC
#define A12_IDX  	4

#define DDR_A13  	DDRC
#define PORT_A13 	PORTC
#define PIN_A13  	PINC
#define A13_IDX  	5

#define DDR_A14  	DDRC
#define PORT_A14 	PORTC
#define PIN_A14  	PINC
#define A14_IDX  	6

#define DDR_A15  	DDRC
#define PORT_A15 	PORTC
#define PIN_A15  	PINC
#define A15_IDX  	7

#define DDR_INT0  	DDRD
#define PORT_INT0 	PORTD
#define PIN_INT0  	PIND
#define INT0_IDX  	0

#define DDR_INT1  	DDRD
#define PORT_INT1 	PORTD
#define PIN_INT1  	PIND
#define INT1_IDX  	1

#define DDR_INT2  	DDRD
#define PORT_INT2 	PORTD
#define PIN_INT2  	PIND
#define INT2_IDX  	2

#define DDR_INT3  	DDRD
#define PORT_INT3 	PORTD
#define PIN_INT3  	PIND
#define INT3_IDX  	3

#define DDR_IC1  	DDRD
#define PORT_IC1 	PORTD
#define PIN_IC1  	PIND
#define IC1_IDX  	4

#define DDR_T1  	DDRD
#define PORT_T1 	PORTD
#define PIN_T1  	PIND
#define T1_IDX  	6

#define DDR_T2  	DDRD
#define PORT_T2 	PORTD
#define PIN_T2  	PIND
#define T2_IDX  	7

#define DDR_RXD0  	DDRE
#define PORT_RXD0 	PORTE
#define PIN_RXD0  	PINE
#define RXD0_IDX  	0

#define DDR_TXD0  	DDRE
#define PORT_TXD0 	PORTE
#define PIN_TXD0  	PINE
#define TXD0_IDX  	1

#define DDR_AC_P  	DDRE
#define PORT_AC_P 	PORTE
#define PIN_AC_P  	PINE
#define AC_P_IDX  	2

#define DDR_AC_N  	DDRE
#define PORT_AC_N 	PORTE
#define PIN_AC_N  	PINE
#define AC_N_IDX  	3

#define DDR_INT4  	DDRE
#define PORT_INT4 	PORTE
#define PIN_INT4  	PINE
#define INT4_IDX  	4

#define DDR_INT5  	DDRE
#define PORT_INT5 	PORTE
#define PIN_INT5  	PINE
#define INT5_IDX  	5

#define DDR_INT6  	DDRE
#define PORT_INT6 	PORTE
#define PIN_INT6  	PINE
#define INT6_IDX  	6

#define DDR_INT7  	DDRE
#define PORT_INT7 	PORTE
#define PIN_INT7  	PINE
#define INT7_IDX  	7

#define DDR_ADC0  	DDRF
#define PORT_ADC0 	PORTF
#define PIN_ADC0  	PINF
#define ADC0_IDX  	0

#define DDR_ADC1  	DDRF
#define PORT_ADC1 	PORTF
#define PIN_ADC1  	PINF
#define ADC1_IDX  	1

#define DDR_ADC2  	DDRF
#define PORT_ADC2 	PORTF
#define PIN_ADC2  	PINF
#define ADC2_IDX  	2

#define DDR_ADC3  	DDRF
#define PORT_ADC3 	PORTF
#define PIN_ADC3  	PINF
#define ADC3_IDX  	3

#define DDR_ADC4  	DDRF
#define PORT_ADC4 	PORTF
#define PIN_ADC4  	PINF
#define ADC4_IDX  	4

#define DDR_ADC5  	DDRF
#define PORT_ADC5 	PORTF
#define PIN_ADC5  	PINF
#define ADC5_IDX  	5

#define DDR_ADC6  	DDRF
#define PORT_ADC6 	PORTF
#define PIN_ADC6  	PINF
#define ADC6_IDX  	6

#define DDR_ADC7  	DDRF
#define PORT_ADC7 	PORTF
#define PIN_ADC7  	PINF
#define ADC7_IDX  	7

