# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_ADC0  	DDRA
#define PORT_ADC0 	PORTA
#define PIN_ADC0  	PINA
#define ADC0_IDX  	0

#define DDR_PCINT0  	DDRA
#define PORT_PCINT0 	PORTA
#define PIN_PCINT0  	PINA
#define PCINT0_IDX  	0

#define DDR_ADC1  	DDRA
#define PORT_ADC1 	PORTA
#define PIN_ADC1  	PINA
#define ADC1_IDX  	1

#define DDR_PCINT1  	DDRA
#define PORT_PCINT1 	PORTA
#define PIN_PCINT1  	PINA
#define PCINT1_IDX  	1

#define DDR_ADC2  	DDRA
#define PORT_ADC2 	PORTA
#define PIN_ADC2  	PINA
#define ADC2_IDX  	2

#define DDR_PCINT2  	DDRA
#define PORT_PCINT2 	PORTA
#define PIN_PCINT2  	PINA
#define PCINT2_IDX  	2

#define DDR_ADC3  	DDRA
#define PORT_ADC3 	PORTA
#define PIN_ADC3  	PINA
#define ADC3_IDX  	3

#define DDR_PCINT3  	DDRA
#define PORT_PCINT3 	PORTA
#define PIN_PCINT3  	PINA
#define PCINT3_IDX  	3

#define DDR_ADC4  	DDRA
#define PORT_ADC4 	PORTA
#define PIN_ADC4  	PINA
#define ADC4_IDX  	4

#define DDR_PCINT4  	DDRA
#define PORT_PCINT4 	PORTA
#define PIN_PCINT4  	PINA
#define PCINT4_IDX  	4

#define DDR_ADC5  	DDRA
#define PORT_ADC5 	PORTA
#define PIN_ADC5  	PINA
#define ADC5_IDX  	5

#define DDR_PCINT5  	DDRA
#define PORT_PCINT5 	PORTA
#define PIN_PCINT5  	PINA
#define PCINT5_IDX  	5

#define DDR_ADC6  	DDRA
#define PORT_ADC6 	PORTA
#define PIN_ADC6  	PINA
#define ADC6_IDX  	6

#define DDR_PCINT6  	DDRA
#define PORT_PCINT6 	PORTA
#define PIN_PCINT6  	PINA
#define PCINT6_IDX  	6

#define DDR_ADC7  	DDRA
#define PORT_ADC7 	PORTA
#define PIN_ADC7  	PINA
#define ADC7_IDX  	7

#define DDR_PCINT7  	DDRA
#define PORT_PCINT7 	PORTA
#define PIN_PCINT7  	PINA
#define PCINT7_IDX  	7

#define DDR_XCK  	DDRB
#define PORT_XCK 	PORTB
#define PIN_XCK  	PINB
#define XCK_IDX  	0

#define DDR_T0  	DDRB
#define PORT_T0 	PORTB
#define PIN_T0  	PINB
#define T0_IDX  	0

#define DDR_PCINT8  	DDRB
#define PORT_PCINT8 	PORTB
#define PIN_PCINT8  	PINB
#define PCINT8_IDX  	0

#define DDR_T1  	DDRB
#define PORT_T1 	PORTB
#define PIN_T1  	PINB
#define T1_IDX  	1

#define DDR_CLKO  	DDRB
#define PORT_CLKO 	PORTB
#define PIN_CLKO  	PINB
#define CLKO_IDX  	1

#define DDR_PCINT9  	DDRB
#define PORT_PCINT9 	PORTB
#define PIN_PCINT9  	PINB
#define PCINT9_IDX  	1

#define DDR_AIN0  	DDRB
#define PORT_AIN0 	PORTB
#define PIN_AIN0  	PINB
#define AIN0_IDX  	2

#define DDR_INT2  	DDRB
#define PORT_INT2 	PORTB
#define PIN_INT2  	PINB
#define INT2_IDX  	2

#define DDR_PCINT10  	DDRB
#define PORT_PCINT10 	PORTB
#define PIN_PCINT10  	PINB
#define PCINT10_IDX  	2

#define DDR_AIN1  	DDRB
#define PORT_AIN1 	PORTB
#define PIN_AIN1  	PINB
#define AIN1_IDX  	3

#define DDR_OC0A  	DDRB
#define PORT_OC0A 	PORTB
#define PIN_OC0A  	PINB
#define OC0A_IDX  	3

#define DDR_PCINT11  	DDRB
#define PORT_PCINT11 	PORTB
#define PIN_PCINT11  	PINB
#define PCINT11_IDX  	3

#define DDR_SS  	DDRB
#define PORT_SS 	PORTB
#define PIN_SS  	PINB
#define SS_IDX  	4

#define DDR_OC0B  	DDRB
#define PORT_OC0B 	PORTB
#define PIN_OC0B  	PINB
#define OC0B_IDX  	4

#define DDR_PCINT12  	DDRB
#define PORT_PCINT12 	PORTB
#define PIN_PCINT12  	PINB
#define PCINT12_IDX  	4

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	5

#define DDR_PCINT13  	DDRB
#define PORT_PCINT13 	PORTB
#define PIN_PCINT13  	PINB
#define PCINT13_IDX  	5

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	6

#define DDR_PCINT14  	DDRB
#define PORT_PCINT14 	PORTB
#define PIN_PCINT14  	PINB
#define PCINT14_IDX  	6

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	7

#define DDR_PCINT15  	DDRB
#define PORT_PCINT15 	PORTB
#define PIN_PCINT15  	PINB
#define PCINT15_IDX  	7

#define DDR_SCL  	DDRC
#define PORT_SCL 	PORTC
#define PIN_SCL  	PINC
#define SCL_IDX  	0

#define DDR_PCINT16  	DDRC
#define PORT_PCINT16 	PORTC
#define PIN_PCINT16  	PINC
#define PCINT16_IDX  	0

#define DDR_SDA  	DDRC
#define PORT_SDA 	PORTC
#define PIN_SDA  	PINC
#define SDA_IDX  	1

#define DDR_PCINT17  	DDRC
#define PORT_PCINT17 	PORTC
#define PIN_PCINT17  	PINC
#define PCINT17_IDX  	1

#define DDR_PCINT18  	DDRC
#define PORT_PCINT18 	PORTC
#define PIN_PCINT18  	PINC
#define PCINT18_IDX  	2

#define DDR_PCINT19  	DDRC
#define PORT_PCINT19 	PORTC
#define PIN_PCINT19  	PINC
#define PCINT19_IDX  	3

#define DDR_PCINT20  	DDRC
#define PORT_PCINT20 	PORTC
#define PIN_PCINT20  	PINC
#define PCINT20_IDX  	4

#define DDR_PCINT21  	DDRC
#define PORT_PCINT21 	PORTC
#define PIN_PCINT21  	PINC
#define PCINT21_IDX  	5

#define DDR_PCINT22  	DDRC
#define PORT_PCINT22 	PORTC
#define PIN_PCINT22  	PINC
#define PCINT22_IDX  	6

#define DDR_PCINT23  	DDRC
#define PORT_PCINT23 	PORTC
#define PIN_PCINT23  	PINC
#define PCINT23_IDX  	7

#define DDR_RXD  	DDRD
#define PORT_RXD 	PORTD
#define PIN_RXD  	PIND
#define RXD_IDX  	0

#define DDR_PCINT24  	DDRD
#define PORT_PCINT24 	PORTD
#define PIN_PCINT24  	PIND
#define PCINT24_IDX  	0

#define DDR_TXD  	DDRD
#define PORT_TXD 	PORTD
#define PIN_TXD  	PIND
#define TXD_IDX  	1

#define DDR_PCINT25  	DDRD
#define PORT_PCINT25 	PORTD
#define PIN_PCINT25  	PIND
#define PCINT25_IDX  	1

#define DDR_INT0  	DDRD
#define PORT_INT0 	PORTD
#define PIN_INT0  	PIND
#define INT0_IDX  	2

#define DDR_RDX1  	DDRD
#define PORT_RDX1 	PORTD
#define PIN_RDX1  	PIND
#define RDX1_IDX  	2

#define DDR_PCINT26  	DDRD
#define PORT_PCINT26 	PORTD
#define PIN_PCINT26  	PIND
#define PCINT26_IDX  	2

#define DDR_INT1  	DDRD
#define PORT_INT1 	PORTD
#define PIN_INT1  	PIND
#define INT1_IDX  	3

#define DDR_TXD1  	DDRD
#define PORT_TXD1 	PORTD
#define PIN_TXD1  	PIND
#define TXD1_IDX  	3

#define DDR_PCINT27  	DDRD
#define PORT_PCINT27 	PORTD
#define PIN_PCINT27  	PIND
#define PCINT27_IDX  	3

#define DDR_OC1B  	DDRD
#define PORT_OC1B 	PORTD
#define PIN_OC1B  	PIND
#define OC1B_IDX  	4

#define DDR_XCK1  	DDRD
#define PORT_XCK1 	PORTD
#define PIN_XCK1  	PIND
#define XCK1_IDX  	4

#define DDR_PCINT28  	DDRD
#define PORT_PCINT28 	PORTD
#define PIN_PCINT28  	PIND
#define PCINT28_IDX  	4

#define DDR_OC1A  	DDRD
#define PORT_OC1A 	PORTD
#define PIN_OC1A  	PIND
#define OC1A_IDX  	5

#define DDR_PCINT29  	DDRD
#define PORT_PCINT29 	PORTD
#define PIN_PCINT29  	PIND
#define PCINT29_IDX  	5

#define DDR_ICP  	DDRD
#define PORT_ICP 	PORTD
#define PIN_ICP  	PIND
#define ICP_IDX  	6

#define DDR_OC2B  	DDRD
#define PORT_OC2B 	PORTD
#define PIN_OC2B  	PIND
#define OC2B_IDX  	6

#define DDR_PCINT30  	DDRD
#define PORT_PCINT30 	PORTD
#define PIN_PCINT30  	PIND
#define PCINT30_IDX  	6

#define DDR_OC2A  	DDRD
#define PORT_OC2A 	PORTD
#define PIN_OC2A  	PIND
#define OC2A_IDX  	7

#define DDR_PCINT31  	DDRD
#define PORT_PCINT31 	PORTD
#define PIN_PCINT31  	PIND
#define PCINT31_IDX  	7

