# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_AD0  	DDRA
#define PORT_AD0 	PORTA
#define PIN_AD0  	PINA
#define AD0_IDX  	0

#define DDR_AD1  	DDRA
#define PORT_AD1 	PORTA
#define PIN_AD1  	PINA
#define AD1_IDX  	1

#define DDR_AD2  	DDRA
#define PORT_AD2 	PORTA
#define PIN_AD2  	PINA
#define AD2_IDX  	2

#define DDR_AD3  	DDRA
#define PORT_AD3 	PORTA
#define PIN_AD3  	PINA
#define AD3_IDX  	3

#define DDR_AD4  	DDRA
#define PORT_AD4 	PORTA
#define PIN_AD4  	PINA
#define AD4_IDX  	4

#define DDR_AD5  	DDRA
#define PORT_AD5 	PORTA
#define PIN_AD5  	PINA
#define AD5_IDX  	5

#define DDR_AD6  	DDRA
#define PORT_AD6 	PORTA
#define PIN_AD6  	PINA
#define AD6_IDX  	6

#define DDR_AD7  	DDRA
#define PORT_AD7 	PORTA
#define PIN_AD7  	PINA
#define AD7_IDX  	7

#define DDR_OC0/T0  	DDRB
#define PORT_OC0/T0 	PORTB
#define PIN_OC0/T0  	PINB
#define OC0/T0_IDX  	0

#define DDR_OC2/T1  	DDRB
#define PORT_OC2/T1 	PORTB
#define PIN_OC2/T1  	PINB
#define OC2/T1_IDX  	1

#define DDR_RXD1  	DDRB
#define PORT_RXD1 	PORTB
#define PIN_RXD1  	PINB
#define RXD1_IDX  	2

#define DDR_AIN0  	DDRB
#define PORT_AIN0 	PORTB
#define PIN_AIN0  	PINB
#define AIN0_IDX  	2

#define DDR_TXD1  	DDRB
#define PORT_TXD1 	PORTB
#define PIN_TXD1  	PINB
#define TXD1_IDX  	3

#define DDR_AIN1  	DDRB
#define PORT_AIN1 	PORTB
#define PIN_AIN1  	PINB
#define AIN1_IDX  	3

#define DDR_SS  	DDRB
#define PORT_SS 	PORTB
#define PIN_SS  	PINB
#define SS_IDX  	4

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	5

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	6

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	7

#define DDR_A8  	DDRC
#define PORT_A8 	PORTC
#define PIN_A8  	PINC
#define A8_IDX  	0

#define DDR_A9  	DDRC
#define PORT_A9 	PORTC
#define PIN_A9  	PINC
#define A9_IDX  	1

#define DDR_A10  	DDRC
#define PORT_A10 	PORTC
#define PIN_A10  	PINC
#define A10_IDX  	2

#define DDR_A11  	DDRC
#define PORT_A11 	PORTC
#define PIN_A11  	PINC
#define A11_IDX  	3

#define DDR_A12  	DDRC
#define PORT_A12 	PORTC
#define PIN_A12  	PINC
#define A12_IDX  	4

#define DDR_A13  	DDRC
#define PORT_A13 	PORTC
#define PIN_A13  	PINC
#define A13_IDX  	5

#define DDR_A14  	DDRC
#define PORT_A14 	PORTC
#define PIN_A14  	PINC
#define A14_IDX  	6

#define DDR_A15  	DDRC
#define PORT_A15 	PORTC
#define PIN_A15  	PINC
#define A15_IDX  	7

#define DDR_RXD  	DDRD
#define PORT_RXD 	PORTD
#define PIN_RXD  	PIND
#define RXD_IDX  	0

#define DDR_TXD  	DDRD
#define PORT_TXD 	PORTD
#define PIN_TXD  	PIND
#define TXD_IDX  	1

#define DDR_INT0  	DDRD
#define PORT_INT0 	PORTD
#define PIN_INT0  	PIND
#define INT0_IDX  	2

#define DDR_INT1  	DDRD
#define PORT_INT1 	PORTD
#define PIN_INT1  	PIND
#define INT1_IDX  	3

#define DDR_OC1A  	DDRD
#define PORT_OC1A 	PORTD
#define PIN_OC1A  	PIND
#define OC1A_IDX  	5

#define DDR_WR  	DDRD
#define PORT_WR 	PORTD
#define PIN_WR  	PIND
#define WR_IDX  	6

#define DDR_RD  	DDRD
#define PORT_RD 	PORTD
#define PIN_RD  	PIND
#define RD_IDX  	7

#define DDR_ICP/INT2  	DDRE
#define PORT_ICP/INT2 	PORTE
#define PIN_ICP/INT2  	PINE
#define ICP/INT2_IDX  	0

#define DDR_ALE  	DDRE
#define PORT_ALE 	PORTE
#define PIN_ALE  	PINE
#define ALE_IDX  	1

#define DDR_OC1B  	DDRE
#define PORT_OC1B 	PORTE
#define PIN_OC1B  	PINE
#define OC1B_IDX  	2

