# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_PCINT0  	DDRA
#define PORT_PCINT0 	PORTA
#define PIN_PCINT0  	PINA
#define PCINT0_IDX  	0

#define DDR_AD0  	DDRA
#define PORT_AD0 	PORTA
#define PIN_AD0  	PINA
#define AD0_IDX  	0

#define DDR_PCINT1  	DDRA
#define PORT_PCINT1 	PORTA
#define PIN_PCINT1  	PINA
#define PCINT1_IDX  	1

#define DDR_AD1  	DDRA
#define PORT_AD1 	PORTA
#define PIN_AD1  	PINA
#define AD1_IDX  	1

#define DDR_PCINT2  	DDRA
#define PORT_PCINT2 	PORTA
#define PIN_PCINT2  	PINA
#define PCINT2_IDX  	2

#define DDR_AD2  	DDRA
#define PORT_AD2 	PORTA
#define PIN_AD2  	PINA
#define AD2_IDX  	2

#define DDR_PCINT3  	DDRA
#define PORT_PCINT3 	PORTA
#define PIN_PCINT3  	PINA
#define PCINT3_IDX  	3

#define DDR_AD3  	DDRA
#define PORT_AD3 	PORTA
#define PIN_AD3  	PINA
#define AD3_IDX  	3

#define DDR_PCINT4  	DDRA
#define PORT_PCINT4 	PORTA
#define PIN_PCINT4  	PINA
#define PCINT4_IDX  	4

#define DDR_AD4  	DDRA
#define PORT_AD4 	PORTA
#define PIN_AD4  	PINA
#define AD4_IDX  	4

#define DDR_PCINT5  	DDRA
#define PORT_PCINT5 	PORTA
#define PIN_PCINT5  	PINA
#define PCINT5_IDX  	5

#define DDR_AD5  	DDRA
#define PORT_AD5 	PORTA
#define PIN_AD5  	PINA
#define AD5_IDX  	5

#define DDR_PCINT6  	DDRA
#define PORT_PCINT6 	PORTA
#define PIN_PCINT6  	PINA
#define PCINT6_IDX  	6

#define DDR_AD6  	DDRA
#define PORT_AD6 	PORTA
#define PIN_AD6  	PINA
#define AD6_IDX  	6

#define DDR_PCINT7  	DDRA
#define PORT_PCINT7 	PORTA
#define PIN_PCINT7  	PINA
#define PCINT7_IDX  	7

#define DDR_AD7  	DDRA
#define PORT_AD7 	PORTA
#define PIN_AD7  	PINA
#define AD7_IDX  	7

#define DDR_OC0  	DDRB
#define PORT_OC0 	PORTB
#define PIN_OC0  	PINB
#define OC0_IDX  	0

#define DDR_T0  	DDRB
#define PORT_T0 	PORTB
#define PIN_T0  	PINB
#define T0_IDX  	0

#define DDR_OC2  	DDRB
#define PORT_OC2 	PORTB
#define PIN_OC2  	PINB
#define OC2_IDX  	1

#define DDR_T1  	DDRB
#define PORT_T1 	PORTB
#define PIN_T1  	PINB
#define T1_IDX  	1

#define DDR_RXD1  	DDRB
#define PORT_RXD1 	PORTB
#define PIN_RXD1  	PINB
#define RXD1_IDX  	2

#define DDR_AIN0  	DDRB
#define PORT_AIN0 	PORTB
#define PIN_AIN0  	PINB
#define AIN0_IDX  	2

#define DDR_TXD1  	DDRB
#define PORT_TXD1 	PORTB
#define PIN_TXD1  	PINB
#define TXD1_IDX  	3

#define DDR_AIN1  	DDRB
#define PORT_AIN1 	PORTB
#define PIN_AIN1  	PINB
#define AIN1_IDX  	3

#define DDR_OC3B  	DDRB
#define PORT_OC3B 	PORTB
#define PIN_OC3B  	PINB
#define OC3B_IDX  	4

#define DDR_SS  	DDRB
#define PORT_SS 	PORTB
#define PIN_SS  	PINB
#define SS_IDX  	4

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	5

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	6

#define DDR_PCINT8  	DDRC
#define PORT_PCINT8 	PORTC
#define PIN_PCINT8  	PINC
#define PCINT8_IDX  	0

#define DDR_A8  	DDRC
#define PORT_A8 	PORTC
#define PIN_A8  	PINC
#define A8_IDX  	0

#define DDR_PCINT9  	DDRC
#define PORT_PCINT9 	PORTC
#define PIN_PCINT9  	PINC
#define PCINT9_IDX  	1

#define DDR_A9  	DDRC
#define PORT_A9 	PORTC
#define PIN_A9  	PINC
#define A9_IDX  	1

#define DDR_PCINT10  	DDRC
#define PORT_PCINT10 	PORTC
#define PIN_PCINT10  	PINC
#define PCINT10_IDX  	2

#define DDR_A10  	DDRC
#define PORT_A10 	PORTC
#define PIN_A10  	PINC
#define A10_IDX  	2

#define DDR_PCINT11  	DDRC
#define PORT_PCINT11 	PORTC
#define PIN_PCINT11  	PINC
#define PCINT11_IDX  	3

#define DDR_A11  	DDRC
#define PORT_A11 	PORTC
#define PIN_A11  	PINC
#define A11_IDX  	3

#define DDR_PCINT12  	DDRC
#define PORT_PCINT12 	PORTC
#define PIN_PCINT12  	PINC
#define PCINT12_IDX  	4

#define DDR_A12  	DDRC
#define PORT_A12 	PORTC
#define PIN_A12  	PINC
#define A12_IDX  	4

#define DDR_PCINT13  	DDRC
#define PORT_PCINT13 	PORTC
#define PIN_PCINT13  	PINC
#define PCINT13_IDX  	5

#define DDR_A13  	DDRC
#define PORT_A13 	PORTC
#define PIN_A13  	PINC
#define A13_IDX  	5

#define DDR_PCINT14  	DDRC
#define PORT_PCINT14 	PORTC
#define PIN_PCINT14  	PINC
#define PCINT14_IDX  	6

#define DDR_A14  	DDRC
#define PORT_A14 	PORTC
#define PIN_A14  	PINC
#define A14_IDX  	6

#define DDR_PCINT15  	DDRC
#define PORT_PCINT15 	PORTC
#define PIN_PCINT15  	PINC
#define PCINT15_IDX  	7

#define DDR_A15  	DDRC
#define PORT_A15 	PORTC
#define PIN_A15  	PINC
#define A15_IDX  	7

#define DDR_TXD0  	DDRD
#define PORT_TXD0 	PORTD
#define PIN_TXD0  	PIND
#define TXD0_IDX  	1

#define DDR_INT0  	DDRD
#define PORT_INT0 	PORTD
#define PIN_INT0  	PIND
#define INT0_IDX  	2

#define DDR_XCK1  	DDRD
#define PORT_XCK1 	PORTD
#define PIN_XCK1  	PIND
#define XCK1_IDX  	2

#define DDR_INT1  	DDRD
#define PORT_INT1 	PORTD
#define PIN_INT1  	PIND
#define INT1_IDX  	3

#define DDR_XCK1  	DDRD
#define PORT_XCK1 	PORTD
#define PIN_XCK1  	PIND
#define XCK1_IDX  	3

#define DDR_XCK0  	DDRD
#define PORT_XCK0 	PORTD
#define PIN_XCK0  	PIND
#define XCK0_IDX  	4

#define DDR_OC3A  	DDRD
#define PORT_OC3A 	PORTD
#define PIN_OC3A  	PIND
#define OC3A_IDX  	4

#define DDR_OC1A  	DDRD
#define PORT_OC1A 	PORTD
#define PIN_OC1A  	PIND
#define OC1A_IDX  	5

#define DDR_WR  	DDRD
#define PORT_WR 	PORTD
#define PIN_WR  	PIND
#define WR_IDX  	6

#define DDR_RD  	DDRD
#define PORT_RD 	PORTD
#define PIN_RD  	PIND
#define RD_IDX  	7

#define DDR_ICP1  	DDRE
#define PORT_ICP1 	PORTE
#define PIN_ICP1  	PINE
#define ICP1_IDX  	0

#define DDR_INT2  	DDRE
#define PORT_INT2 	PORTE
#define PIN_INT2  	PINE
#define INT2_IDX  	0

#define DDR_ALE  	DDRE
#define PORT_ALE 	PORTE
#define PIN_ALE  	PINE
#define ALE_IDX  	1

#define DDR_OC1B  	DDRE
#define PORT_OC1B 	PORTE
#define PIN_OC1B  	PINE
#define OC1B_IDX  	2

