# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_COM0  	DDRA
#define PORT_COM0 	PORTA
#define PIN_COM0  	PINA
#define COM0_IDX  	0

#define DDR_COM1  	DDRA
#define PORT_COM1 	PORTA
#define PIN_COM1  	PINA
#define COM1_IDX  	1

#define DDR_COM2  	DDRA
#define PORT_COM2 	PORTA
#define PIN_COM2  	PINA
#define COM2_IDX  	2

#define DDR_COM3  	DDRA
#define PORT_COM3 	PORTA
#define PIN_COM3  	PINA
#define COM3_IDX  	3

#define DDR_SEG0  	DDRA
#define PORT_SEG0 	PORTA
#define PIN_SEG0  	PINA
#define SEG0_IDX  	4

#define DDR_SEG1  	DDRA
#define PORT_SEG1 	PORTA
#define PIN_SEG1  	PINA
#define SEG1_IDX  	5

#define DDR_SEG2  	DDRA
#define PORT_SEG2 	PORTA
#define PIN_SEG2  	PINA
#define SEG2_IDX  	6

#define DDR_SEG3  	DDRA
#define PORT_SEG3 	PORTA
#define PIN_SEG3  	PINA
#define SEG3_IDX  	7

#define DDR_SS  	DDRB
#define PORT_SS 	PORTB
#define PIN_SS  	PINB
#define SS_IDX  	0

#define DDR_PCINT8  	DDRB
#define PORT_PCINT8 	PORTB
#define PIN_PCINT8  	PINB
#define PCINT8_IDX  	0

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	1

#define DDR_PCINT9  	DDRB
#define PORT_PCINT9 	PORTB
#define PIN_PCINT9  	PINB
#define PCINT9_IDX  	1

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	2

#define DDR_PCINT10  	DDRB
#define PORT_PCINT10 	PORTB
#define PIN_PCINT10  	PINB
#define PCINT10_IDX  	2

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	3

#define DDR_PCINT11  	DDRB
#define PORT_PCINT11 	PORTB
#define PIN_PCINT11  	PINB
#define PCINT11_IDX  	3

#define DDR_OC0A  	DDRB
#define PORT_OC0A 	PORTB
#define PIN_OC0A  	PINB
#define OC0A_IDX  	4

#define DDR_PCINT12  	DDRB
#define PORT_PCINT12 	PORTB
#define PIN_PCINT12  	PINB
#define PCINT12_IDX  	4

#define DDR_OC1A  	DDRB
#define PORT_OC1A 	PORTB
#define PIN_OC1A  	PINB
#define OC1A_IDX  	5

#define DDR_PCINT13  	DDRB
#define PORT_PCINT13 	PORTB
#define PIN_PCINT13  	PINB
#define PCINT13_IDX  	5

#define DDR_OC1B  	DDRB
#define PORT_OC1B 	PORTB
#define PIN_OC1B  	PINB
#define OC1B_IDX  	6

#define DDR_PCINT14  	DDRB
#define PORT_PCINT14 	PORTB
#define PIN_PCINT14  	PINB
#define PCINT14_IDX  	6

#define DDR_OC2A  	DDRB
#define PORT_OC2A 	PORTB
#define PIN_OC2A  	PINB
#define OC2A_IDX  	7

#define DDR_PCINT15  	DDRB
#define PORT_PCINT15 	PORTB
#define PIN_PCINT15  	PINB
#define PCINT15_IDX  	7

#define DDR_SEG16  	DDRC
#define PORT_SEG16 	PORTC
#define PIN_SEG16  	PINC
#define SEG16_IDX  	0

#define DDR_SEG15  	DDRC
#define PORT_SEG15 	PORTC
#define PIN_SEG15  	PINC
#define SEG15_IDX  	1

#define DDR_SEG14  	DDRC
#define PORT_SEG14 	PORTC
#define PIN_SEG14  	PINC
#define SEG14_IDX  	2

#define DDR_SEG13  	DDRC
#define PORT_SEG13 	PORTC
#define PIN_SEG13  	PINC
#define SEG13_IDX  	3

#define DDR_SEG12  	DDRC
#define PORT_SEG12 	PORTC
#define PIN_SEG12  	PINC
#define SEG12_IDX  	4

#define DDR_SEG11  	DDRC
#define PORT_SEG11 	PORTC
#define PIN_SEG11  	PINC
#define SEG11_IDX  	5

#define DDR_SEG6  	DDRC
#define PORT_SEG6 	PORTC
#define PIN_SEG6  	PINC
#define SEG6_IDX  	6

#define DDR_SEG5  	DDRC
#define PORT_SEG5 	PORTC
#define PIN_SEG5  	PINC
#define SEG5_IDX  	7

#define DDR_ICP1  	DDRD
#define PORT_ICP1 	PORTD
#define PIN_ICP1  	PIND
#define ICP1_IDX  	0

#define DDR_SEG26  	DDRD
#define PORT_SEG26 	PORTD
#define PIN_SEG26  	PIND
#define SEG26_IDX  	0

#define DDR_INT0  	DDRD
#define PORT_INT0 	PORTD
#define PIN_INT0  	PIND
#define INT0_IDX  	1

#define DDR_SEG25  	DDRD
#define PORT_SEG25 	PORTD
#define PIN_SEG25  	PIND
#define SEG25_IDX  	1

#define DDR_SEG24  	DDRD
#define PORT_SEG24 	PORTD
#define PIN_SEG24  	PIND
#define SEG24_IDX  	2

#define DDR_SEG23  	DDRD
#define PORT_SEG23 	PORTD
#define PIN_SEG23  	PIND
#define SEG23_IDX  	3

#define DDR_SEG22  	DDRD
#define PORT_SEG22 	PORTD
#define PIN_SEG22  	PIND
#define SEG22_IDX  	4

#define DDR_SEG21  	DDRD
#define PORT_SEG21 	PORTD
#define PIN_SEG21  	PIND
#define SEG21_IDX  	5

#define DDR_SEG20  	DDRD
#define PORT_SEG20 	PORTD
#define PIN_SEG20  	PIND
#define SEG20_IDX  	6

#define DDR_SEG19  	DDRD
#define PORT_SEG19 	PORTD
#define PIN_SEG19  	PIND
#define SEG19_IDX  	7

#define DDR_RXD  	DDRE
#define PORT_RXD 	PORTE
#define PIN_RXD  	PINE
#define RXD_IDX  	0

#define DDR_PCINT0  	DDRE
#define PORT_PCINT0 	PORTE
#define PIN_PCINT0  	PINE
#define PCINT0_IDX  	0

#define DDR_TXD  	DDRE
#define PORT_TXD 	PORTE
#define PIN_TXD  	PINE
#define TXD_IDX  	1

#define DDR_PCINT1  	DDRE
#define PORT_PCINT1 	PORTE
#define PIN_PCINT1  	PINE
#define PCINT1_IDX  	1

#define DDR_XCK  	DDRE
#define PORT_XCK 	PORTE
#define PIN_XCK  	PINE
#define XCK_IDX  	2

#define DDR_AIN0  	DDRE
#define PORT_AIN0 	PORTE
#define PIN_AIN0  	PINE
#define AIN0_IDX  	2

#define DDR_PCINT2  	DDRE
#define PORT_PCINT2 	PORTE
#define PIN_PCINT2  	PINE
#define PCINT2_IDX  	2

#define DDR_AIN1  	DDRE
#define PORT_AIN1 	PORTE
#define PIN_AIN1  	PINE
#define AIN1_IDX  	3

#define DDR_PCINT3  	DDRE
#define PORT_PCINT3 	PORTE
#define PIN_PCINT3  	PINE
#define PCINT3_IDX  	3

#define DDR_USCK  	DDRE
#define PORT_USCK 	PORTE
#define PIN_USCK  	PINE
#define USCK_IDX  	4

#define DDR_SCL  	DDRE
#define PORT_SCL 	PORTE
#define PIN_SCL  	PINE
#define SCL_IDX  	4

#define DDR_PCINT4  	DDRE
#define PORT_PCINT4 	PORTE
#define PIN_PCINT4  	PINE
#define PCINT4_IDX  	4

#define DDR_DI  	DDRE
#define PORT_DI 	PORTE
#define PIN_DI  	PINE
#define DI_IDX  	5

#define DDR_SDA  	DDRE
#define PORT_SDA 	PORTE
#define PIN_SDA  	PINE
#define SDA_IDX  	5

#define DDR_PCINT5  	DDRE
#define PORT_PCINT5 	PORTE
#define PIN_PCINT5  	PINE
#define PCINT5_IDX  	5

#define DDR_DO  	DDRE
#define PORT_DO 	PORTE
#define PIN_DO  	PINE
#define DO_IDX  	6

#define DDR_PCINT6  	DDRE
#define PORT_PCINT6 	PORTE
#define PIN_PCINT6  	PINE
#define PCINT6_IDX  	6

#define DDR_CLKO  	DDRE
#define PORT_CLKO 	PORTE
#define PIN_CLKO  	PINE
#define CLKO_IDX  	7

#define DDR_PCINT7  	DDRE
#define PORT_PCINT7 	PORTE
#define PIN_PCINT7  	PINE
#define PCINT7_IDX  	7

#define DDR_ADC0  	DDRF
#define PORT_ADC0 	PORTF
#define PIN_ADC0  	PINF
#define ADC0_IDX  	0

#define DDR_ADC1  	DDRF
#define PORT_ADC1 	PORTF
#define PIN_ADC1  	PINF
#define ADC1_IDX  	1

#define DDR_ADC2  	DDRF
#define PORT_ADC2 	PORTF
#define PIN_ADC2  	PINF
#define ADC2_IDX  	2

#define DDR_ADC3  	DDRF
#define PORT_ADC3 	PORTF
#define PIN_ADC3  	PINF
#define ADC3_IDX  	3

#define DDR_ADC4  	DDRF
#define PORT_ADC4 	PORTF
#define PIN_ADC4  	PINF
#define ADC4_IDX  	4

#define DDR_ADC5  	DDRF
#define PORT_ADC5 	PORTF
#define PIN_ADC5  	PINF
#define ADC5_IDX  	5

#define DDR_ADC6  	DDRF
#define PORT_ADC6 	PORTF
#define PIN_ADC6  	PINF
#define ADC6_IDX  	6

#define DDR_ADC7  	DDRF
#define PORT_ADC7 	PORTF
#define PIN_ADC7  	PINF
#define ADC7_IDX  	7

#define DDR_SEG18  	DDRG
#define PORT_SEG18 	PORTG
#define PIN_SEG18  	PING
#define SEG18_IDX  	0

#define DDR_SEG17  	DDRG
#define PORT_SEG17 	PORTG
#define PIN_SEG17  	PING
#define SEG17_IDX  	1

#define DDR_SEG4  	DDRG
#define PORT_SEG4 	PORTG
#define PIN_SEG4  	PING
#define SEG4_IDX  	2

#define DDR_T1  	DDRG
#define PORT_T1 	PORTG
#define PIN_T1  	PING
#define T1_IDX  	3

#define DDR_SEG33  	DDRG
#define PORT_SEG33 	PORTG
#define PIN_SEG33  	PING
#define SEG33_IDX  	3

#define DDR_T0  	DDRG
#define PORT_T0 	PORTG
#define PIN_T0  	PING
#define T0_IDX  	4

#define DDR_SEG32  	DDRG
#define PORT_SEG32 	PORTG
#define PIN_SEG32  	PING
#define SEG32_IDX  	4

#define DDR_PCINT16  	DDRH
#define PORT_PCINT16 	PORTH
#define PIN_PCINT16  	PINH
#define PCINT16_IDX  	0

#define DDR_SEG10  	DDRH
#define PORT_SEG10 	PORTH
#define PIN_SEG10  	PINH
#define SEG10_IDX  	0

#define DDR_PCINT17  	DDRH
#define PORT_PCINT17 	PORTH
#define PIN_PCINT17  	PINH
#define PCINT17_IDX  	1

#define DDR_SEG9  	DDRH
#define PORT_SEG9 	PORTH
#define PIN_SEG9  	PINH
#define SEG9_IDX  	1

#define DDR_PCINT18  	DDRH
#define PORT_PCINT18 	PORTH
#define PIN_PCINT18  	PINH
#define PCINT18_IDX  	2

#define DDR_SEG8  	DDRH
#define PORT_SEG8 	PORTH
#define PIN_SEG8  	PINH
#define SEG8_IDX  	2

#define DDR_PCINT19  	DDRH
#define PORT_PCINT19 	PORTH
#define PIN_PCINT19  	PINH
#define PCINT19_IDX  	3

#define DDR_SEG7  	DDRH
#define PORT_SEG7 	PORTH
#define PIN_SEG7  	PINH
#define SEG7_IDX  	3

#define DDR_PCINT20  	DDRH
#define PORT_PCINT20 	PORTH
#define PIN_PCINT20  	PINH
#define PCINT20_IDX  	4

#define DDR_SEG39  	DDRH
#define PORT_SEG39 	PORTH
#define PIN_SEG39  	PINH
#define SEG39_IDX  	4

#define DDR_PCINT21  	DDRH
#define PORT_PCINT21 	PORTH
#define PIN_PCINT21  	PINH
#define PCINT21_IDX  	5

#define DDR_SEG38  	DDRH
#define PORT_SEG38 	PORTH
#define PIN_SEG38  	PINH
#define SEG38_IDX  	5

#define DDR_PCINT22  	DDRH
#define PORT_PCINT22 	PORTH
#define PIN_PCINT22  	PINH
#define PCINT22_IDX  	6

#define DDR_SEG37  	DDRH
#define PORT_SEG37 	PORTH
#define PIN_SEG37  	PINH
#define SEG37_IDX  	6

#define DDR_PCINT23  	DDRH
#define PORT_PCINT23 	PORTH
#define PIN_PCINT23  	PINH
#define PCINT23_IDX  	7

#define DDR_SEG36  	DDRH
#define PORT_SEG36 	PORTH
#define PIN_SEG36  	PINH
#define SEG36_IDX  	7

#define DDR_PCINT24  	DDRJ
#define PORT_PCINT24 	PORTJ
#define PIN_PCINT24  	PINJ
#define PCINT24_IDX  	0

#define DDR_SEG35  	DDRJ
#define PORT_SEG35 	PORTJ
#define PIN_SEG35  	PINJ
#define SEG35_IDX  	0

#define DDR_PCINT25  	DDRJ
#define PORT_PCINT25 	PORTJ
#define PIN_PCINT25  	PINJ
#define PCINT25_IDX  	1

#define DDR_SEG33  	DDRJ
#define PORT_SEG33 	PORTJ
#define PIN_SEG33  	PINJ
#define SEG33_IDX  	1

#define DDR_PCINT26  	DDRJ
#define PORT_PCINT26 	PORTJ
#define PIN_PCINT26  	PINJ
#define PCINT26_IDX  	2

#define DDR_SEG31  	DDRJ
#define PORT_SEG31 	PORTJ
#define PIN_SEG31  	PINJ
#define SEG31_IDX  	2

#define DDR_PCINT27  	DDRJ
#define PORT_PCINT27 	PORTJ
#define PIN_PCINT27  	PINJ
#define PCINT27_IDX  	3

#define DDR_SEG30  	DDRJ
#define PORT_SEG30 	PORTJ
#define PIN_SEG30  	PINJ
#define SEG30_IDX  	3

#define DDR_PCINT28  	DDRJ
#define PORT_PCINT28 	PORTJ
#define PIN_PCINT28  	PINJ
#define PCINT28_IDX  	4

#define DDR_SEG29  	DDRJ
#define PORT_SEG29 	PORTJ
#define PIN_SEG29  	PINJ
#define SEG29_IDX  	4

#define DDR_PCINT29  	DDRJ
#define PORT_PCINT29 	PORTJ
#define PIN_PCINT29  	PINJ
#define PCINT29_IDX  	5

#define DDR_SEG28  	DDRJ
#define PORT_SEG28 	PORTJ
#define PIN_SEG28  	PINJ
#define SEG28_IDX  	5

#define DDR_PCINT30  	DDRJ
#define PORT_PCINT30 	PORTJ
#define PIN_PCINT30  	PINJ
#define PCINT30_IDX  	6

#define DDR_SEG27  	DDRJ
#define PORT_SEG27 	PORTJ
#define PIN_SEG27  	PINJ
#define SEG27_IDX  	6

