# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_COM0  	DDRA
#define PORT_COM0 	PORTA
#define PIN_COM0  	PINA
#define COM0_IDX  	0

#define DDR_COM1  	DDRA
#define PORT_COM1 	PORTA
#define PIN_COM1  	PINA
#define COM1_IDX  	1

#define DDR_COM2  	DDRA
#define PORT_COM2 	PORTA
#define PIN_COM2  	PINA
#define COM2_IDX  	2

#define DDR_COM3  	DDRA
#define PORT_COM3 	PORTA
#define PIN_COM3  	PINA
#define COM3_IDX  	3

#define DDR_SEG0  	DDRA
#define PORT_SEG0 	PORTA
#define PIN_SEG0  	PINA
#define SEG0_IDX  	4

#define DDR_SEG1  	DDRA
#define PORT_SEG1 	PORTA
#define PIN_SEG1  	PINA
#define SEG1_IDX  	5

#define DDR_SEG2  	DDRA
#define PORT_SEG2 	PORTA
#define PIN_SEG2  	PINA
#define SEG2_IDX  	6

#define DDR_SEG3  	DDRA
#define PORT_SEG3 	PORTA
#define PIN_SEG3  	PINA
#define SEG3_IDX  	7

#define DDR_SS  	DDRB
#define PORT_SS 	PORTB
#define PIN_SS  	PINB
#define SS_IDX  	0

#define DDR_PCINT8  	DDRB
#define PORT_PCINT8 	PORTB
#define PIN_PCINT8  	PINB
#define PCINT8_IDX  	0

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	1

#define DDR_PCINT9  	DDRB
#define PORT_PCINT9 	PORTB
#define PIN_PCINT9  	PINB
#define PCINT9_IDX  	1

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	2

#define DDR_PCINT10  	DDRB
#define PORT_PCINT10 	PORTB
#define PIN_PCINT10  	PINB
#define PCINT10_IDX  	2

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	3

#define DDR_PCINT11  	DDRB
#define PORT_PCINT11 	PORTB
#define PIN_PCINT11  	PINB
#define PCINT11_IDX  	3

#define DDR_OC0  	DDRB
#define PORT_OC0 	PORTB
#define PIN_OC0  	PINB
#define OC0_IDX  	4

#define DDR_PCINT12  	DDRB
#define PORT_PCINT12 	PORTB
#define PIN_PCINT12  	PINB
#define PCINT12_IDX  	4

#define DDR_OC1A  	DDRB
#define PORT_OC1A 	PORTB
#define PIN_OC1A  	PINB
#define OC1A_IDX  	5

#define DDR_PCINT13  	DDRB
#define PORT_PCINT13 	PORTB
#define PIN_PCINT13  	PINB
#define PCINT13_IDX  	5

#define DDR_OC1B  	DDRB
#define PORT_OC1B 	PORTB
#define PIN_OC1B  	PINB
#define OC1B_IDX  	6

#define DDR_PCINT14  	DDRB
#define PORT_PCINT14 	PORTB
#define PIN_PCINT14  	PINB
#define PCINT14_IDX  	6

#define DDR_OC2  	DDRB
#define PORT_OC2 	PORTB
#define PIN_OC2  	PINB
#define OC2_IDX  	7

#define DDR_PCINT15  	DDRB
#define PORT_PCINT15 	PORTB
#define PIN_PCINT15  	PINB
#define PCINT15_IDX  	7

#define DDR_SEG12  	DDRC
#define PORT_SEG12 	PORTC
#define PIN_SEG12  	PINC
#define SEG12_IDX  	0

#define DDR_SEG11  	DDRC
#define PORT_SEG11 	PORTC
#define PIN_SEG11  	PINC
#define SEG11_IDX  	1

#define DDR_SEG10  	DDRC
#define PORT_SEG10 	PORTC
#define PIN_SEG10  	PINC
#define SEG10_IDX  	2

#define DDR_SEG9  	DDRC
#define PORT_SEG9 	PORTC
#define PIN_SEG9  	PINC
#define SEG9_IDX  	3

#define DDR_SEG8  	DDRC
#define PORT_SEG8 	PORTC
#define PIN_SEG8  	PINC
#define SEG8_IDX  	4

#define DDR_SEG7  	DDRC
#define PORT_SEG7 	PORTC
#define PIN_SEG7  	PINC
#define SEG7_IDX  	5

#define DDR_SEG6  	DDRC
#define PORT_SEG6 	PORTC
#define PIN_SEG6  	PINC
#define SEG6_IDX  	6

#define DDR_SEG5  	DDRC
#define PORT_SEG5 	PORTC
#define PIN_SEG5  	PINC
#define SEG5_IDX  	7

#define DDR_ICP/SEG22  	DDRD
#define PORT_ICP/SEG22 	PORTD
#define PIN_ICP/SEG22  	PIND
#define ICP/SEG22_IDX  	0

#define DDR_INT0/SEG21  	DDRD
#define PORT_INT0/SEG21 	PORTD
#define PIN_INT0/SEG21  	PIND
#define INT0/SEG21_IDX  	1

#define DDR_SEG20  	DDRD
#define PORT_SEG20 	PORTD
#define PIN_SEG20  	PIND
#define SEG20_IDX  	2

#define DDR_SEG19  	DDRD
#define PORT_SEG19 	PORTD
#define PIN_SEG19  	PIND
#define SEG19_IDX  	3

#define DDR_SEG18  	DDRD
#define PORT_SEG18 	PORTD
#define PIN_SEG18  	PIND
#define SEG18_IDX  	4

#define DDR_SEG17  	DDRD
#define PORT_SEG17 	PORTD
#define PIN_SEG17  	PIND
#define SEG17_IDX  	5

#define DDR_SEG16  	DDRD
#define PORT_SEG16 	PORTD
#define PIN_SEG16  	PIND
#define SEG16_IDX  	6

#define DDR_SEG15  	DDRD
#define PORT_SEG15 	PORTD
#define PIN_SEG15  	PIND
#define SEG15_IDX  	7

#define DDR_RXD  	DDRE
#define PORT_RXD 	PORTE
#define PIN_RXD  	PINE
#define RXD_IDX  	0

#define DDR_PCINT0  	DDRE
#define PORT_PCINT0 	PORTE
#define PIN_PCINT0  	PINE
#define PCINT0_IDX  	0

#define DDR_TXD  	DDRE
#define PORT_TXD 	PORTE
#define PIN_TXD  	PINE
#define TXD_IDX  	1

#define DDR_PCINT1  	DDRE
#define PORT_PCINT1 	PORTE
#define PIN_PCINT1  	PINE
#define PCINT1_IDX  	1

#define DDR_XCK  	DDRE
#define PORT_XCK 	PORTE
#define PIN_XCK  	PINE
#define XCK_IDX  	2

#define DDR_AIN0  	DDRE
#define PORT_AIN0 	PORTE
#define PIN_AIN0  	PINE
#define AIN0_IDX  	2

#define DDR_PCINT2  	DDRE
#define PORT_PCINT2 	PORTE
#define PIN_PCINT2  	PINE
#define PCINT2_IDX  	2

#define DDR_AIN1  	DDRE
#define PORT_AIN1 	PORTE
#define PIN_AIN1  	PINE
#define AIN1_IDX  	3

#define DDR_PCINT3  	DDRE
#define PORT_PCINT3 	PORTE
#define PIN_PCINT3  	PINE
#define PCINT3_IDX  	3

#define DDR_USCK  	DDRE
#define PORT_USCK 	PORTE
#define PIN_USCK  	PINE
#define USCK_IDX  	4

#define DDR_SCL  	DDRE
#define PORT_SCL 	PORTE
#define PIN_SCL  	PINE
#define SCL_IDX  	4

#define DDR_PCINT4  	DDRE
#define PORT_PCINT4 	PORTE
#define PIN_PCINT4  	PINE
#define PCINT4_IDX  	4

#define DDR_DI  	DDRE
#define PORT_DI 	PORTE
#define PIN_DI  	PINE
#define DI_IDX  	5

#define DDR_SDA  	DDRE
#define PORT_SDA 	PORTE
#define PIN_SDA  	PINE
#define SDA_IDX  	5

#define DDR_PCINT5  	DDRE
#define PORT_PCINT5 	PORTE
#define PIN_PCINT5  	PINE
#define PCINT5_IDX  	5

#define DDR_DO  	DDRE
#define PORT_DO 	PORTE
#define PIN_DO  	PINE
#define DO_IDX  	6

#define DDR_PCINT6  	DDRE
#define PORT_PCINT6 	PORTE
#define PIN_PCINT6  	PINE
#define PCINT6_IDX  	6

#define DDR_PCINT7  	DDRE
#define PORT_PCINT7 	PORTE
#define PIN_PCINT7  	PINE
#define PCINT7_IDX  	7

#define DDR_ADC0  	DDRF
#define PORT_ADC0 	PORTF
#define PIN_ADC0  	PINF
#define ADC0_IDX  	0

#define DDR_ADC1  	DDRF
#define PORT_ADC1 	PORTF
#define PIN_ADC1  	PINF
#define ADC1_IDX  	1

#define DDR_ADC2  	DDRF
#define PORT_ADC2 	PORTF
#define PIN_ADC2  	PINF
#define ADC2_IDX  	2

#define DDR_ADC3  	DDRF
#define PORT_ADC3 	PORTF
#define PIN_ADC3  	PINF
#define ADC3_IDX  	3

#define DDR_ADC4  	DDRF
#define PORT_ADC4 	PORTF
#define PIN_ADC4  	PINF
#define ADC4_IDX  	4

#define DDR_ADC5  	DDRF
#define PORT_ADC5 	PORTF
#define PIN_ADC5  	PINF
#define ADC5_IDX  	5

#define DDR_ADC6  	DDRF
#define PORT_ADC6 	PORTF
#define PIN_ADC6  	PINF
#define ADC6_IDX  	6

#define DDR_ADC7  	DDRF
#define PORT_ADC7 	PORTF
#define PIN_ADC7  	PINF
#define ADC7_IDX  	7

#define DDR_SEG14  	DDRG
#define PORT_SEG14 	PORTG
#define PIN_SEG14  	PING
#define SEG14_IDX  	0

#define DDR_SEG13  	DDRG
#define PORT_SEG13 	PORTG
#define PIN_SEG13  	PING
#define SEG13_IDX  	1

#define DDR_SEG4  	DDRG
#define PORT_SEG4 	PORTG
#define PIN_SEG4  	PING
#define SEG4_IDX  	2

#define DDR_T1  	DDRG
#define PORT_T1 	PORTG
#define PIN_T1  	PING
#define T1_IDX  	3

#define DDR_SEG24  	DDRG
#define PORT_SEG24 	PORTG
#define PIN_SEG24  	PING
#define SEG24_IDX  	3

#define DDR_T0  	DDRG
#define PORT_T0 	PORTG
#define PIN_T0  	PING
#define T0_IDX  	4

#define DDR_SEG23  	DDRG
#define PORT_SEG23 	PORTG
#define PIN_SEG23  	PING
#define SEG23_IDX  	4

