# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_ICP1  	DDRB
#define PORT_ICP1 	PORTB
#define PIN_ICP1  	PINB
#define ICP1_IDX  	0

#define DDR_CLKO  	DDRB
#define PORT_CLKO 	PORTB
#define PIN_CLKO  	PINB
#define CLKO_IDX  	0

#define DDR_PCINT0  	DDRB
#define PORT_PCINT0 	PORTB
#define PIN_PCINT0  	PINB
#define PCINT0_IDX  	0

#define DDR_OC1A  	DDRB
#define PORT_OC1A 	PORTB
#define PIN_OC1A  	PINB
#define OC1A_IDX  	1

#define DDR_PCINT1  	DDRB
#define PORT_PCINT1 	PORTB
#define PIN_PCINT1  	PINB
#define PCINT1_IDX  	1

#define DDR_SS  	DDRB
#define PORT_SS 	PORTB
#define PIN_SS  	PINB
#define SS_IDX  	2

#define DDR_OC1B  	DDRB
#define PORT_OC1B 	PORTB
#define PIN_OC1B  	PINB
#define OC1B_IDX  	2

#define DDR_PCINT2  	DDRB
#define PORT_PCINT2 	PORTB
#define PIN_PCINT2  	PINB
#define PCINT2_IDX  	2

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	3

#define DDR_OC2A  	DDRB
#define PORT_OC2A 	PORTB
#define PIN_OC2A  	PINB
#define OC2A_IDX  	3

#define DDR_PCINT3  	DDRB
#define PORT_PCINT3 	PORTB
#define PIN_PCINT3  	PINB
#define PCINT3_IDX  	3

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	4

#define DDR_PCINT4  	DDRB
#define PORT_PCINT4 	PORTB
#define PIN_PCINT4  	PINB
#define PCINT4_IDX  	4

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	5

#define DDR_PCINT5  	DDRB
#define PORT_PCINT5 	PORTB
#define PIN_PCINT5  	PINB
#define PCINT5_IDX  	5

#define DDR_TOSC1  	DDRB
#define PORT_TOSC1 	PORTB
#define PIN_TOSC1  	PINB
#define TOSC1_IDX  	6

#define DDR_PCINT6  	DDRB
#define PORT_PCINT6 	PORTB
#define PIN_PCINT6  	PINB
#define PCINT6_IDX  	6

#define DDR_TOSC2  	DDRB
#define PORT_TOSC2 	PORTB
#define PIN_TOSC2  	PINB
#define TOSC2_IDX  	7

#define DDR_PCINT7  	DDRB
#define PORT_PCINT7 	PORTB
#define PIN_PCINT7  	PINB
#define PCINT7_IDX  	7

#define DDR_ADC0  	DDRC
#define PORT_ADC0 	PORTC
#define PIN_ADC0  	PINC
#define ADC0_IDX  	0

#define DDR_PCINT8  	DDRC
#define PORT_PCINT8 	PORTC
#define PIN_PCINT8  	PINC
#define PCINT8_IDX  	0

#define DDR_ADC1  	DDRC
#define PORT_ADC1 	PORTC
#define PIN_ADC1  	PINC
#define ADC1_IDX  	1

#define DDR_PCINT9  	DDRC
#define PORT_PCINT9 	PORTC
#define PIN_PCINT9  	PINC
#define PCINT9_IDX  	1

#define DDR_ADC2  	DDRC
#define PORT_ADC2 	PORTC
#define PIN_ADC2  	PINC
#define ADC2_IDX  	2

#define DDR_PCINT10  	DDRC
#define PORT_PCINT10 	PORTC
#define PIN_PCINT10  	PINC
#define PCINT10_IDX  	2

#define DDR_ADC3  	DDRC
#define PORT_ADC3 	PORTC
#define PIN_ADC3  	PINC
#define ADC3_IDX  	3

#define DDR_PCINT11  	DDRC
#define PORT_PCINT11 	PORTC
#define PIN_PCINT11  	PINC
#define PCINT11_IDX  	3

#define DDR_ADC4  	DDRC
#define PORT_ADC4 	PORTC
#define PIN_ADC4  	PINC
#define ADC4_IDX  	4

#define DDR_SDA  	DDRC
#define PORT_SDA 	PORTC
#define PIN_SDA  	PINC
#define SDA_IDX  	4

#define DDR_PCINT12  	DDRC
#define PORT_PCINT12 	PORTC
#define PIN_PCINT12  	PINC
#define PCINT12_IDX  	4

#define DDR_ADC5  	DDRC
#define PORT_ADC5 	PORTC
#define PIN_ADC5  	PINC
#define ADC5_IDX  	5

#define DDR_SCL  	DDRC
#define PORT_SCL 	PORTC
#define PIN_SCL  	PINC
#define SCL_IDX  	5

#define DDR_PCINT13  	DDRC
#define PORT_PCINT13 	PORTC
#define PIN_PCINT13  	PINC
#define PCINT13_IDX  	5

#define DDR_PCINT14  	DDRC
#define PORT_PCINT14 	PORTC
#define PIN_PCINT14  	PINC
#define PCINT14_IDX  	6

#define DDR_RXD  	DDRD
#define PORT_RXD 	PORTD
#define PIN_RXD  	PIND
#define RXD_IDX  	0

#define DDR_PCINT16  	DDRD
#define PORT_PCINT16 	PORTD
#define PIN_PCINT16  	PIND
#define PCINT16_IDX  	0

#define DDR_TXD  	DDRD
#define PORT_TXD 	PORTD
#define PIN_TXD  	PIND
#define TXD_IDX  	1

#define DDR_PCINT17  	DDRD
#define PORT_PCINT17 	PORTD
#define PIN_PCINT17  	PIND
#define PCINT17_IDX  	1

#define DDR_INT0  	DDRD
#define PORT_INT0 	PORTD
#define PIN_INT0  	PIND
#define INT0_IDX  	2

#define DDR_PCINT18  	DDRD
#define PORT_PCINT18 	PORTD
#define PIN_PCINT18  	PIND
#define PCINT18_IDX  	2

#define DDR_PCINT19  	DDRD
#define PORT_PCINT19 	PORTD
#define PIN_PCINT19  	PIND
#define PCINT19_IDX  	3

#define DDR_OC2B  	DDRD
#define PORT_OC2B 	PORTD
#define PIN_OC2B  	PIND
#define OC2B_IDX  	3

#define DDR_INT1  	DDRD
#define PORT_INT1 	PORTD
#define PIN_INT1  	PIND
#define INT1_IDX  	3

#define DDR_XCK  	DDRD
#define PORT_XCK 	PORTD
#define PIN_XCK  	PIND
#define XCK_IDX  	4

#define DDR_T0  	DDRD
#define PORT_T0 	PORTD
#define PIN_T0  	PIND
#define T0_IDX  	4

#define DDR_PCINT20  	DDRD
#define PORT_PCINT20 	PORTD
#define PIN_PCINT20  	PIND
#define PCINT20_IDX  	4

#define DDR_T1  	DDRD
#define PORT_T1 	PORTD
#define PIN_T1  	PIND
#define T1_IDX  	5

#define DDR_OC0B  	DDRD
#define PORT_OC0B 	PORTD
#define PIN_OC0B  	PIND
#define OC0B_IDX  	5

#define DDR_PCINT21  	DDRD
#define PORT_PCINT21 	PORTD
#define PIN_PCINT21  	PIND
#define PCINT21_IDX  	5

#define DDR_AIN0  	DDRD
#define PORT_AIN0 	PORTD
#define PIN_AIN0  	PIND
#define AIN0_IDX  	6

#define DDR_OC0A  	DDRD
#define PORT_OC0A 	PORTD
#define PIN_OC0A  	PIND
#define OC0A_IDX  	6

#define DDR_PCINT22  	DDRD
#define PORT_PCINT22 	PORTD
#define PIN_PCINT22  	PIND
#define PCINT22_IDX  	6

#define DDR_AIN1  	DDRD
#define PORT_AIN1 	PORTD
#define PIN_AIN1  	PIND
#define AIN1_IDX  	7

#define DDR_PCINT23  	DDRD
#define PORT_PCINT23 	PORTD
#define PIN_PCINT23  	PIND
#define PCINT23_IDX  	7

