# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_AD0  	DDRA
#define PORT_AD0 	PORTA
#define PIN_AD0  	PINA
#define AD0_IDX  	0

#define DDR_AD1  	DDRA
#define PORT_AD1 	PORTA
#define PIN_AD1  	PINA
#define AD1_IDX  	1

#define DDR_AD2  	DDRA
#define PORT_AD2 	PORTA
#define PIN_AD2  	PINA
#define AD2_IDX  	2

#define DDR_AD3  	DDRA
#define PORT_AD3 	PORTA
#define PIN_AD3  	PINA
#define AD3_IDX  	3

#define DDR_AD4  	DDRA
#define PORT_AD4 	PORTA
#define PIN_AD4  	PINA
#define AD4_IDX  	4

#define DDR_AD5  	DDRA
#define PORT_AD5 	PORTA
#define PIN_AD5  	PINA
#define AD5_IDX  	5

#define DDR_AD6  	DDRA
#define PORT_AD6 	PORTA
#define PIN_AD6  	PINA
#define AD6_IDX  	6

#define DDR_AD7  	DDRA
#define PORT_AD7 	PORTA
#define PIN_AD7  	PINA
#define AD7_IDX  	7

#define DDR_SS  	DDRB
#define PORT_SS 	PORTB
#define PIN_SS  	PINB
#define SS_IDX  	0

#define DDR_PCINT0  	DDRB
#define PORT_PCINT0 	PORTB
#define PIN_PCINT0  	PINB
#define PCINT0_IDX  	0

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	1

#define DDR_PCINT1  	DDRB
#define PORT_PCINT1 	PORTB
#define PIN_PCINT1  	PINB
#define PCINT1_IDX  	1

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	2

#define DDR_PCINT2  	DDRB
#define PORT_PCINT2 	PORTB
#define PIN_PCINT2  	PINB
#define PCINT2_IDX  	2

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	3

#define DDR_PCINT3  	DDRB
#define PORT_PCINT3 	PORTB
#define PIN_PCINT3  	PINB
#define PCINT3_IDX  	3

#define DDR_OC2A  	DDRB
#define PORT_OC2A 	PORTB
#define PIN_OC2A  	PINB
#define OC2A_IDX  	4

#define DDR_PCINT4  	DDRB
#define PORT_PCINT4 	PORTB
#define PIN_PCINT4  	PINB
#define PCINT4_IDX  	4

#define DDR_OC1A  	DDRB
#define PORT_OC1A 	PORTB
#define PIN_OC1A  	PINB
#define OC1A_IDX  	5

#define DDR_PCINT5  	DDRB
#define PORT_PCINT5 	PORTB
#define PIN_PCINT5  	PINB
#define PCINT5_IDX  	5

#define DDR_OC1B  	DDRB
#define PORT_OC1B 	PORTB
#define PIN_OC1B  	PINB
#define OC1B_IDX  	6

#define DDR_PCINT6  	DDRB
#define PORT_PCINT6 	PORTB
#define PIN_PCINT6  	PINB
#define PCINT6_IDX  	6

#define DDR_OC0A  	DDRB
#define PORT_OC0A 	PORTB
#define PIN_OC0A  	PINB
#define OC0A_IDX  	7

#define DDR_OC1C  	DDRB
#define PORT_OC1C 	PORTB
#define PIN_OC1C  	PINB
#define OC1C_IDX  	7

#define DDR_PCINT7  	DDRB
#define PORT_PCINT7 	PORTB
#define PIN_PCINT7  	PINB
#define PCINT7_IDX  	7

#define DDR_A8  	DDRC
#define PORT_A8 	PORTC
#define PIN_A8  	PINC
#define A8_IDX  	0

#define DDR_A9  	DDRC
#define PORT_A9 	PORTC
#define PIN_A9  	PINC
#define A9_IDX  	1

#define DDR_A10  	DDRC
#define PORT_A10 	PORTC
#define PIN_A10  	PINC
#define A10_IDX  	2

#define DDR_A11  	DDRC
#define PORT_A11 	PORTC
#define PIN_A11  	PINC
#define A11_IDX  	3

#define DDR_A12  	DDRC
#define PORT_A12 	PORTC
#define PIN_A12  	PINC
#define A12_IDX  	4

#define DDR_A13  	DDRC
#define PORT_A13 	PORTC
#define PIN_A13  	PINC
#define A13_IDX  	5

#define DDR_A14  	DDRC
#define PORT_A14 	PORTC
#define PIN_A14  	PINC
#define A14_IDX  	6

#define DDR_A15  	DDRC
#define PORT_A15 	PORTC
#define PIN_A15  	PINC
#define A15_IDX  	7

#define DDR_SCL  	DDRD
#define PORT_SCL 	PORTD
#define PIN_SCL  	PIND
#define SCL_IDX  	0

#define DDR_INT0  	DDRD
#define PORT_INT0 	PORTD
#define PIN_INT0  	PIND
#define INT0_IDX  	0

#define DDR_SDA  	DDRD
#define PORT_SDA 	PORTD
#define PIN_SDA  	PIND
#define SDA_IDX  	1

#define DDR_INT1  	DDRD
#define PORT_INT1 	PORTD
#define PIN_INT1  	PIND
#define INT1_IDX  	1

#define DDR_RXD1  	DDRD
#define PORT_RXD1 	PORTD
#define PIN_RXD1  	PIND
#define RXD1_IDX  	2

#define DDR_INT2  	DDRD
#define PORT_INT2 	PORTD
#define PIN_INT2  	PIND
#define INT2_IDX  	2

#define DDR_TXD1  	DDRD
#define PORT_TXD1 	PORTD
#define PIN_TXD1  	PIND
#define TXD1_IDX  	3

#define DDR_INT3  	DDRD
#define PORT_INT3 	PORTD
#define PIN_INT3  	PIND
#define INT3_IDX  	3

#define DDR_ICP1  	DDRD
#define PORT_ICP1 	PORTD
#define PIN_ICP1  	PIND
#define ICP1_IDX  	4

#define DDR_XCK1  	DDRD
#define PORT_XCK1 	PORTD
#define PIN_XCK1  	PIND
#define XCK1_IDX  	5

#define DDR_T1  	DDRD
#define PORT_T1 	PORTD
#define PIN_T1  	PIND
#define T1_IDX  	6

#define DDR_T0  	DDRD
#define PORT_T0 	PORTD
#define PIN_T0  	PIND
#define T0_IDX  	7

#define DDR_RXD  	DDRE
#define PORT_RXD 	PORTE
#define PIN_RXD  	PINE
#define RXD_IDX  	0

#define DDR_PCINT8  	DDRE
#define PORT_PCINT8 	PORTE
#define PIN_PCINT8  	PINE
#define PCINT8_IDX  	0

#define DDR_TXD0  	DDRE
#define PORT_TXD0 	PORTE
#define PIN_TXD0  	PINE
#define TXD0_IDX  	1

#define DDR_XCK  	DDRE
#define PORT_XCK 	PORTE
#define PIN_XCK  	PINE
#define XCK_IDX  	2

#define DDR_AIN0  	DDRE
#define PORT_AIN0 	PORTE
#define PIN_AIN0  	PINE
#define AIN0_IDX  	2

#define DDR_OC3A  	DDRE
#define PORT_OC3A 	PORTE
#define PIN_OC3A  	PINE
#define OC3A_IDX  	3

#define DDR_AIN1  	DDRE
#define PORT_AIN1 	PORTE
#define PIN_AIN1  	PINE
#define AIN1_IDX  	3

#define DDR_OC3B  	DDRE
#define PORT_OC3B 	PORTE
#define PIN_OC3B  	PINE
#define OC3B_IDX  	4

#define DDR_INT4  	DDRE
#define PORT_INT4 	PORTE
#define PIN_INT4  	PINE
#define INT4_IDX  	4

#define DDR_OC3C  	DDRE
#define PORT_OC3C 	PORTE
#define PIN_OC3C  	PINE
#define OC3C_IDX  	5

#define DDR_INT5  	DDRE
#define PORT_INT5 	PORTE
#define PIN_INT5  	PINE
#define INT5_IDX  	5

#define DDR_T3  	DDRE
#define PORT_T3 	PORTE
#define PIN_T3  	PINE
#define T3_IDX  	6

#define DDR_INT6  	DDRE
#define PORT_INT6 	PORTE
#define PIN_INT6  	PINE
#define INT6_IDX  	6

#define DDR_CLKO  	DDRE
#define PORT_CLKO 	PORTE
#define PIN_CLKO  	PINE
#define CLKO_IDX  	7

#define DDR_ICP3  	DDRE
#define PORT_ICP3 	PORTE
#define PIN_ICP3  	PINE
#define ICP3_IDX  	7

#define DDR_INT7  	DDRE
#define PORT_INT7 	PORTE
#define PIN_INT7  	PINE
#define INT7_IDX  	7

#define DDR_ADC0  	DDRF
#define PORT_ADC0 	PORTF
#define PIN_ADC0  	PINF
#define ADC0_IDX  	0

#define DDR_ADC1  	DDRF
#define PORT_ADC1 	PORTF
#define PIN_ADC1  	PINF
#define ADC1_IDX  	1

#define DDR_ADC2  	DDRF
#define PORT_ADC2 	PORTF
#define PIN_ADC2  	PINF
#define ADC2_IDX  	2

#define DDR_ADC3  	DDRF
#define PORT_ADC3 	PORTF
#define PIN_ADC3  	PINF
#define ADC3_IDX  	3

#define DDR_ADC4  	DDRF
#define PORT_ADC4 	PORTF
#define PIN_ADC4  	PINF
#define ADC4_IDX  	4

#define DDR_ADC5  	DDRF
#define PORT_ADC5 	PORTF
#define PIN_ADC5  	PINF
#define ADC5_IDX  	5

#define DDR_ADC6  	DDRF
#define PORT_ADC6 	PORTF
#define PIN_ADC6  	PINF
#define ADC6_IDX  	6

#define DDR_ADC7  	DDRF
#define PORT_ADC7 	PORTF
#define PIN_ADC7  	PINF
#define ADC7_IDX  	7

#define DDR_WR  	DDRG
#define PORT_WR 	PORTG
#define PIN_WR  	PING
#define WR_IDX  	0

#define DDR_RD  	DDRG
#define PORT_RD 	PORTG
#define PIN_RD  	PING
#define RD_IDX  	1

#define DDR_ALE  	DDRG
#define PORT_ALE 	PORTG
#define PIN_ALE  	PING
#define ALE_IDX  	2

#define DDR_OC0B  	DDRG
#define PORT_OC0B 	PORTG
#define PIN_OC0B  	PING
#define OC0B_IDX  	5

#define DDR_RXD2  	DDRH
#define PORT_RXD2 	PORTH
#define PIN_RXD2  	PINH
#define RXD2_IDX  	0

#define DDR_TXD2  	DDRH
#define PORT_TXD2 	PORTH
#define PIN_TXD2  	PINH
#define TXD2_IDX  	1

#define DDR_XCK2  	DDRH
#define PORT_XCK2 	PORTH
#define PIN_XCK2  	PINH
#define XCK2_IDX  	2

#define DDR_OC4A  	DDRH
#define PORT_OC4A 	PORTH
#define PIN_OC4A  	PINH
#define OC4A_IDX  	3

#define DDR_OC4B  	DDRH
#define PORT_OC4B 	PORTH
#define PIN_OC4B  	PINH
#define OC4B_IDX  	4

#define DDR_OC4C  	DDRH
#define PORT_OC4C 	PORTH
#define PIN_OC4C  	PINH
#define OC4C_IDX  	5

#define DDR_OC2B  	DDRH
#define PORT_OC2B 	PORTH
#define PIN_OC2B  	PINH
#define OC2B_IDX  	6

#define DDR_T4  	DDRH
#define PORT_T4 	PORTH
#define PIN_T4  	PINH
#define T4_IDX  	7

#define DDR_RXD3  	DDRJ
#define PORT_RXD3 	PORTJ
#define PIN_RXD3  	PINJ
#define RXD3_IDX  	0

#define DDR_PCINT9  	DDRJ
#define PORT_PCINT9 	PORTJ
#define PIN_PCINT9  	PINJ
#define PCINT9_IDX  	0

#define DDR_TXD3  	DDRJ
#define PORT_TXD3 	PORTJ
#define PIN_TXD3  	PINJ
#define TXD3_IDX  	1

#define DDR_PCINT10  	DDRJ
#define PORT_PCINT10 	PORTJ
#define PIN_PCINT10  	PINJ
#define PCINT10_IDX  	1

#define DDR_XCK3  	DDRJ
#define PORT_XCK3 	PORTJ
#define PIN_XCK3  	PINJ
#define XCK3_IDX  	2

#define DDR_PCINT11  	DDRJ
#define PORT_PCINT11 	PORTJ
#define PIN_PCINT11  	PINJ
#define PCINT11_IDX  	2

#define DDR_PCINT12  	DDRJ
#define PORT_PCINT12 	PORTJ
#define PIN_PCINT12  	PINJ
#define PCINT12_IDX  	3

#define DDR_PCINT13  	DDRJ
#define PORT_PCINT13 	PORTJ
#define PIN_PCINT13  	PINJ
#define PCINT13_IDX  	4

#define DDR_PCINT14  	DDRJ
#define PORT_PCINT14 	PORTJ
#define PIN_PCINT14  	PINJ
#define PCINT14_IDX  	5

#define DDR_PCINT15  	DDRJ
#define PORT_PCINT15 	PORTJ
#define PIN_PCINT15  	PINJ
#define PCINT15_IDX  	6

#define DDR_ADC8  	DDRK
#define PORT_ADC8 	PORTK
#define PIN_ADC8  	PINK
#define ADC8_IDX  	0

#define DDR_PCINT16  	DDRK
#define PORT_PCINT16 	PORTK
#define PIN_PCINT16  	PINK
#define PCINT16_IDX  	0

#define DDR_ADC9  	DDRK
#define PORT_ADC9 	PORTK
#define PIN_ADC9  	PINK
#define ADC9_IDX  	1

#define DDR_PCINT17  	DDRK
#define PORT_PCINT17 	PORTK
#define PIN_PCINT17  	PINK
#define PCINT17_IDX  	1

#define DDR_ADC10  	DDRK
#define PORT_ADC10 	PORTK
#define PIN_ADC10  	PINK
#define ADC10_IDX  	2

#define DDR_PCINT18  	DDRK
#define PORT_PCINT18 	PORTK
#define PIN_PCINT18  	PINK
#define PCINT18_IDX  	2

#define DDR_ADC11  	DDRK
#define PORT_ADC11 	PORTK
#define PIN_ADC11  	PINK
#define ADC11_IDX  	3

#define DDR_PCINT19  	DDRK
#define PORT_PCINT19 	PORTK
#define PIN_PCINT19  	PINK
#define PCINT19_IDX  	3

#define DDR_ADC12  	DDRK
#define PORT_ADC12 	PORTK
#define PIN_ADC12  	PINK
#define ADC12_IDX  	4

#define DDR_PCINT20  	DDRK
#define PORT_PCINT20 	PORTK
#define PIN_PCINT20  	PINK
#define PCINT20_IDX  	4

#define DDR_ADC13  	DDRK
#define PORT_ADC13 	PORTK
#define PIN_ADC13  	PINK
#define ADC13_IDX  	5

#define DDR_PCINT21  	DDRK
#define PORT_PCINT21 	PORTK
#define PIN_PCINT21  	PINK
#define PCINT21_IDX  	5

#define DDR_ADC14  	DDRK
#define PORT_ADC14 	PORTK
#define PIN_ADC14  	PINK
#define ADC14_IDX  	6

#define DDR_PCINT22  	DDRK
#define PORT_PCINT22 	PORTK
#define PIN_PCINT22  	PINK
#define PCINT22_IDX  	6

#define DDR_ADC15  	DDRK
#define PORT_ADC15 	PORTK
#define PIN_ADC15  	PINK
#define ADC15_IDX  	7

#define DDR_PCINT23  	DDRK
#define PORT_PCINT23 	PORTK
#define PIN_PCINT23  	PINK
#define PCINT23_IDX  	7

#define DDR_ICP4  	DDRL
#define PORT_ICP4 	PORTL
#define PIN_ICP4  	PINL
#define ICP4_IDX  	0

#define DDR_ICP5  	DDRL
#define PORT_ICP5 	PORTL
#define PIN_ICP5  	PINL
#define ICP5_IDX  	1

#define DDR_T5  	DDRL
#define PORT_T5 	PORTL
#define PIN_T5  	PINL
#define T5_IDX  	2

#define DDR_OC5A  	DDRL
#define PORT_OC5A 	PORTL
#define PIN_OC5A  	PINL
#define OC5A_IDX  	3

#define DDR_OC5B  	DDRL
#define PORT_OC5B 	PORTL
#define PIN_OC5B  	PINL
#define OC5B_IDX  	4

#define DDR_OC5C  	DDRL
#define PORT_OC5C 	PORTL
#define PIN_OC5C  	PINL
#define OC5C_IDX  	5

