# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_ADC0  	DDRA
#define PORT_ADC0 	PORTA
#define PIN_ADC0  	PINA
#define ADC0_IDX  	0

#define DDR_PCINT0  	DDRA
#define PORT_PCINT0 	PORTA
#define PIN_PCINT0  	PINA
#define PCINT0_IDX  	0

#define DDR_ADC1  	DDRA
#define PORT_ADC1 	PORTA
#define PIN_ADC1  	PINA
#define ADC1_IDX  	1

#define DDR_AIN0  	DDRA
#define PORT_AIN0 	PORTA
#define PIN_AIN0  	PINA
#define AIN0_IDX  	1

#define DDR_PCINT1  	DDRA
#define PORT_PCINT1 	PORTA
#define PIN_PCINT1  	PINA
#define PCINT1_IDX  	1

#define DDR_ADC2  	DDRA
#define PORT_ADC2 	PORTA
#define PIN_ADC2  	PINA
#define ADC2_IDX  	2

#define DDR_AIN1  	DDRA
#define PORT_AIN1 	PORTA
#define PIN_AIN1  	PINA
#define AIN1_IDX  	2

#define DDR_PCINT2  	DDRA
#define PORT_PCINT2 	PORTA
#define PIN_PCINT2  	PINA
#define PCINT2_IDX  	2

#define DDR_ADC3  	DDRA
#define PORT_ADC3 	PORTA
#define PIN_ADC3  	PINA
#define ADC3_IDX  	3

#define DDR_T0  	DDRA
#define PORT_T0 	PORTA
#define PIN_T0  	PINA
#define T0_IDX  	3

#define DDR_PCINT3  	DDRA
#define PORT_PCINT3 	PORTA
#define PIN_PCINT3  	PINA
#define PCINT3_IDX  	3

#define DDR_ADC4  	DDRA
#define PORT_ADC4 	PORTA
#define PIN_ADC4  	PINA
#define ADC4_IDX  	4

#define DDR_USCK  	DDRA
#define PORT_USCK 	PORTA
#define PIN_USCK  	PINA
#define USCK_IDX  	4

#define DDR_SCL  	DDRA
#define PORT_SCL 	PORTA
#define PIN_SCL  	PINA
#define SCL_IDX  	4

#define DDR_T1  	DDRA
#define PORT_T1 	PORTA
#define PIN_T1  	PINA
#define T1_IDX  	4

#define DDR_PCINT4  	DDRA
#define PORT_PCINT4 	PORTA
#define PIN_PCINT4  	PINA
#define PCINT4_IDX  	4

#define DDR_ADC5  	DDRA
#define PORT_ADC5 	PORTA
#define PIN_ADC5  	PINA
#define ADC5_IDX  	5

#define DDR_DO  	DDRA
#define PORT_DO 	PORTA
#define PIN_DO  	PINA
#define DO_IDX  	5

#define DDR_MISO  	DDRA
#define PORT_MISO 	PORTA
#define PIN_MISO  	PINA
#define MISO_IDX  	5

#define DDR_OC1B  	DDRA
#define PORT_OC1B 	PORTA
#define PIN_OC1B  	PINA
#define OC1B_IDX  	5

#define DDR_PCINT5  	DDRA
#define PORT_PCINT5 	PORTA
#define PIN_PCINT5  	PINA
#define PCINT5_IDX  	5

#define DDR_PCINT6  	DDRA
#define PORT_PCINT6 	PORTA
#define PIN_PCINT6  	PINA
#define PCINT6_IDX  	6

#define DDR_OC1A  	DDRA
#define PORT_OC1A 	PORTA
#define PIN_OC1A  	PINA
#define OC1A_IDX  	6

#define DDR_DI  	DDRA
#define PORT_DI 	PORTA
#define PIN_DI  	PINA
#define DI_IDX  	6

#define DDR_SDA  	DDRA
#define PORT_SDA 	PORTA
#define PIN_SDA  	PINA
#define SDA_IDX  	6

#define DDR_MOSI  	DDRA
#define PORT_MOSI 	PORTA
#define PIN_MOSI  	PINA
#define MOSI_IDX  	6

#define DDR_ADC6  	DDRA
#define PORT_ADC6 	PORTA
#define PIN_ADC6  	PINA
#define ADC6_IDX  	6

#define DDR_PCINT7  	DDRA
#define PORT_PCINT7 	PORTA
#define PIN_PCINT7  	PINA
#define PCINT7_IDX  	7

#define DDR_ICP1  	DDRA
#define PORT_ICP1 	PORTA
#define PIN_ICP1  	PINA
#define ICP1_IDX  	7

#define DDR_OC0B  	DDRA
#define PORT_OC0B 	PORTA
#define PIN_OC0B  	PINA
#define OC0B_IDX  	7

#define DDR_ADC7  	DDRA
#define PORT_ADC7 	PORTA
#define PIN_ADC7  	PINA
#define ADC7_IDX  	7

#define DDR_PCINT8  	DDRB
#define PORT_PCINT8 	PORTB
#define PIN_PCINT8  	PINB
#define PCINT8_IDX  	0

#define DDR_PCINT9  	DDRB
#define PORT_PCINT9 	PORTB
#define PIN_PCINT9  	PINB
#define PCINT9_IDX  	1

#define DDR_PCINT10  	DDRB
#define PORT_PCINT10 	PORTB
#define PIN_PCINT10  	PINB
#define PCINT10_IDX  	2

#define DDR_INT0  	DDRB
#define PORT_INT0 	PORTB
#define PIN_INT0  	PINB
#define INT0_IDX  	2

#define DDR_OC0A  	DDRB
#define PORT_OC0A 	PORTB
#define PIN_OC0A  	PINB
#define OC0A_IDX  	2

#define DDR_CKOUT  	DDRB
#define PORT_CKOUT 	PORTB
#define PIN_CKOUT  	PINB
#define CKOUT_IDX  	2

#define DDR_PCINT11  	DDRB
#define PORT_PCINT11 	PORTB
#define PIN_PCINT11  	PINB
#define PCINT11_IDX  	3

#define DDR_dW  	DDRB
#define PORT_dW 	PORTB
#define PIN_dW  	PINB
#define dW_IDX  	3

