# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	0

#define DDR_DI  	DDRB
#define PORT_DI 	PORTB
#define PIN_DI  	PINB
#define DI_IDX  	0

#define DDR_SDA  	DDRB
#define PORT_SDA 	PORTB
#define PIN_SDA  	PINB
#define SDA_IDX  	0

#define DDR_AIN0  	DDRB
#define PORT_AIN0 	PORTB
#define PIN_AIN0  	PINB
#define AIN0_IDX  	0

#define DDR_OC0A  	DDRB
#define PORT_OC0A 	PORTB
#define PIN_OC0A  	PINB
#define OC0A_IDX  	0

#define DDR_OC1A  	DDRB
#define PORT_OC1A 	PORTB
#define PIN_OC1A  	PINB
#define OC1A_IDX  	0

#define DDR_PCINT0  	DDRB
#define PORT_PCINT0 	PORTB
#define PIN_PCINT0  	PINB
#define PCINT0_IDX  	0

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	1

#define DDR_DO  	DDRB
#define PORT_DO 	PORTB
#define PIN_DO  	PINB
#define DO_IDX  	1

#define DDR_AIN1  	DDRB
#define PORT_AIN1 	PORTB
#define PIN_AIN1  	PINB
#define AIN1_IDX  	1

#define DDR_OC0B  	DDRB
#define PORT_OC0B 	PORTB
#define PIN_OC0B  	PINB
#define OC0B_IDX  	1

#define DDR_OC1A  	DDRB
#define PORT_OC1A 	PORTB
#define PIN_OC1A  	PINB
#define OC1A_IDX  	1

#define DDR_PCINT1  	DDRB
#define PORT_PCINT1 	PORTB
#define PIN_PCINT1  	PINB
#define PCINT1_IDX  	1

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	2

#define DDR_USCK  	DDRB
#define PORT_USCK 	PORTB
#define PIN_USCK  	PINB
#define USCK_IDX  	2

#define DDR_SCL  	DDRB
#define PORT_SCL 	PORTB
#define PIN_SCL  	PINB
#define SCL_IDX  	2

#define DDR_ADC1  	DDRB
#define PORT_ADC1 	PORTB
#define PIN_ADC1  	PINB
#define ADC1_IDX  	2

#define DDR_T0  	DDRB
#define PORT_T0 	PORTB
#define PIN_T0  	PINB
#define T0_IDX  	2

#define DDR_INT0  	DDRB
#define PORT_INT0 	PORTB
#define PIN_INT0  	PINB
#define INT0_IDX  	2

#define DDR_PCINT2  	DDRB
#define PORT_PCINT2 	PORTB
#define PIN_PCINT2  	PINB
#define PCINT2_IDX  	2

#define DDR_ADC3  	DDRB
#define PORT_ADC3 	PORTB
#define PIN_ADC3  	PINB
#define ADC3_IDX  	3

#define DDR_OC1B  	DDRB
#define PORT_OC1B 	PORTB
#define PIN_OC1B  	PINB
#define OC1B_IDX  	3

#define DDR_PCINT4  	DDRB
#define PORT_PCINT4 	PORTB
#define PIN_PCINT4  	PINB
#define PCINT4_IDX  	3

#define DDR_ADC2  	DDRB
#define PORT_ADC2 	PORTB
#define PIN_ADC2  	PINB
#define ADC2_IDX  	4

#define DDR_OC1B  	DDRB
#define PORT_OC1B 	PORTB
#define PIN_OC1B  	PINB
#define OC1B_IDX  	4

#define DDR_PCINT3  	DDRB
#define PORT_PCINT3 	PORTB
#define PIN_PCINT3  	PINB
#define PCINT3_IDX  	4

#define DDR_ADC0  	DDRB
#define PORT_ADC0 	PORTB
#define PIN_ADC0  	PINB
#define ADC0_IDX  	5

#define DDR_PCINT5  	DDRB
#define PORT_PCINT5 	PORTB
#define PIN_PCINT5  	PINB
#define PCINT5_IDX  	5

#define DDR_dW  	DDRB
#define PORT_dW 	PORTB
#define PIN_dW  	PINB
#define dW_IDX  	5

