# Copyright (c) 2009, Frédéric Nadeau
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
#
# * Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
#
# * Neither the name of the copyright holders nor the names of
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
#


/* Device Pin Definitions */
#define DDR_ADC0  	DDRA
#define PORT_ADC0 	PORTA
#define PIN_ADC0  	PINA
#define ADC0_IDX  	0

#define DDR_DI_A  	DDRA
#define PORT_DI_A 	PORTA
#define PIN_DI_A  	PINA
#define DI_A_IDX  	0

#define DDR_SDA_A  	DDRA
#define PORT_SDA_A 	PORTA
#define PIN_SDA_A  	PINA
#define SDA_A_IDX  	0

#define DDR_PCINT0  	DDRA
#define PORT_PCINT0 	PORTA
#define PIN_PCINT0  	PINA
#define PCINT0_IDX  	0

#define DDR_ADC1  	DDRA
#define PORT_ADC1 	PORTA
#define PIN_ADC1  	PINA
#define ADC1_IDX  	1

#define DDR_DO_A  	DDRA
#define PORT_DO_A 	PORTA
#define PIN_DO_A  	PINA
#define DO_A_IDX  	1

#define DDR_PCINT1  	DDRA
#define PORT_PCINT1 	PORTA
#define PIN_PCINT1  	PINA
#define PCINT1_IDX  	1

#define DDR_ADC2  	DDRA
#define PORT_ADC2 	PORTA
#define PIN_ADC2  	PINA
#define ADC2_IDX  	2

#define DDR_INT1  	DDRA
#define PORT_INT1 	PORTA
#define PIN_INT1  	PINA
#define INT1_IDX  	2

#define DDR_USCK_A  	DDRA
#define PORT_USCK_A 	PORTA
#define PIN_USCK_A  	PINA
#define USCK_A_IDX  	2

#define DDR_SCL_A  	DDRA
#define PORT_SCL_A 	PORTA
#define PIN_SCL_A  	PINA
#define SCL_A_IDX  	2

#define DDR_PCINT2  	DDRA
#define PORT_PCINT2 	PORTA
#define PIN_PCINT2  	PINA
#define PCINT2_IDX  	2

#define DDR_PCINT3  	DDRA
#define PORT_PCINT3 	PORTA
#define PIN_PCINT3  	PINA
#define PCINT3_IDX  	3

#define DDR_ADC3  	DDRA
#define PORT_ADC3 	PORTA
#define PIN_ADC3  	PINA
#define ADC3_IDX  	4

#define DDR_ICP0  	DDRA
#define PORT_ICP0 	PORTA
#define PIN_ICP0  	PINA
#define ICP0_IDX  	4

#define DDR_PCINT4  	DDRA
#define PORT_PCINT4 	PORTA
#define PIN_PCINT4  	PINA
#define PCINT4_IDX  	4

#define DDR_ADC4  	DDRA
#define PORT_ADC4 	PORTA
#define PIN_ADC4  	PINA
#define ADC4_IDX  	5

#define DDR_AIN2  	DDRA
#define PORT_AIN2 	PORTA
#define PIN_AIN2  	PINA
#define AIN2_IDX  	5

#define DDR_PCINT5  	DDRA
#define PORT_PCINT5 	PORTA
#define PIN_PCINT5  	PINA
#define PCINT5_IDX  	5

#define DDR_ADC5  	DDRA
#define PORT_ADC5 	PORTA
#define PIN_ADC5  	PINA
#define ADC5_IDX  	6

#define DDR_AIN0  	DDRA
#define PORT_AIN0 	PORTA
#define PIN_AIN0  	PINA
#define AIN0_IDX  	6

#define DDR_PCINT6  	DDRA
#define PORT_PCINT6 	PORTA
#define PIN_PCINT6  	PINA
#define PCINT6_IDX  	6

#define DDR_ADC6  	DDRA
#define PORT_ADC6 	PORTA
#define PIN_ADC6  	PINA
#define ADC6_IDX  	7

#define DDR_AIN1  	DDRA
#define PORT_AIN1 	PORTA
#define PIN_AIN1  	PINA
#define AIN1_IDX  	7

#define DDR_PCINT7  	DDRA
#define PORT_PCINT7 	PORTA
#define PIN_PCINT7  	PINA
#define PCINT7_IDX  	7

#define DDR_MOSI  	DDRB
#define PORT_MOSI 	PORTB
#define PIN_MOSI  	PINB
#define MOSI_IDX  	0

#define DDR_DI_B  	DDRB
#define PORT_DI_B 	PORTB
#define PIN_DI_B  	PINB
#define DI_B_IDX  	0

#define DDR_SDA_B  	DDRB
#define PORT_SDA_B 	PORTB
#define PIN_SDA_B  	PINB
#define SDA_B_IDX  	0

#define DDR__OC1A  	DDRB
#define PORT__OC1A 	PORTB
#define PIN__OC1A  	PINB
#define _OC1A_IDX  	0

#define DDR_PCINT8  	DDRB
#define PORT_PCINT8 	PORTB
#define PIN_PCINT8  	PINB
#define PCINT8_IDX  	0

#define DDR_MISO  	DDRB
#define PORT_MISO 	PORTB
#define PIN_MISO  	PINB
#define MISO_IDX  	1

#define DDR_DO_B  	DDRB
#define PORT_DO_B 	PORTB
#define PIN_DO_B  	PINB
#define DO_B_IDX  	1

#define DDR_OC1A  	DDRB
#define PORT_OC1A 	PORTB
#define PIN_OC1A  	PINB
#define OC1A_IDX  	1

#define DDR_PCINT9  	DDRB
#define PORT_PCINT9 	PORTB
#define PIN_PCINT9  	PINB
#define PCINT9_IDX  	1

#define DDR_SCK  	DDRB
#define PORT_SCK 	PORTB
#define PIN_SCK  	PINB
#define SCK_IDX  	2

#define DDR_USCK_B  	DDRB
#define PORT_USCK_B 	PORTB
#define PIN_USCK_B  	PINB
#define USCK_B_IDX  	2

#define DDR_SCL_B  	DDRB
#define PORT_SCL_B 	PORTB
#define PIN_SCL_B  	PINB
#define SCL_B_IDX  	2

#define DDR_OC1B  	DDRB
#define PORT_OC1B 	PORTB
#define PIN_OC1B  	PINB
#define OC1B_IDX  	2

#define DDR_PCINT10  	DDRB
#define PORT_PCINT10 	PORTB
#define PIN_PCINT10  	PINB
#define PCINT10_IDX  	2

#define DDR_OC1B  	DDRB
#define PORT_OC1B 	PORTB
#define PIN_OC1B  	PINB
#define OC1B_IDX  	3

#define DDR_PCINT11  	DDRB
#define PORT_PCINT11 	PORTB
#define PIN_PCINT11  	PINB
#define PCINT11_IDX  	3

#define DDR_ADC7  	DDRB
#define PORT_ADC7 	PORTB
#define PIN_ADC7  	PINB
#define ADC7_IDX  	4

#define DDR_PCINT12  	DDRB
#define PORT_PCINT12 	PORTB
#define PIN_PCINT12  	PINB
#define PCINT12_IDX  	4

#define DDR__OC1D  	DDRB
#define PORT__OC1D 	PORTB
#define PIN__OC1D  	PINB
#define _OC1D_IDX  	4

#define DDR_CLKI  	DDRB
#define PORT_CLKI 	PORTB
#define PIN_CLKI  	PINB
#define CLKI_IDX  	4

#define DDR_ADC8  	DDRB
#define PORT_ADC8 	PORTB
#define PIN_ADC8  	PINB
#define ADC8_IDX  	5

#define DDR_PCINT13  	DDRB
#define PORT_PCINT13 	PORTB
#define PIN_PCINT13  	PINB
#define PCINT13_IDX  	5

#define DDR_OC1D  	DDRB
#define PORT_OC1D 	PORTB
#define PIN_OC1D  	PINB
#define OC1D_IDX  	5

#define DDR_CKLO  	DDRB
#define PORT_CKLO 	PORTB
#define PIN_CKLO  	PINB
#define CKLO_IDX  	5

#define DDR_ADC9  	DDRB
#define PORT_ADC9 	PORTB
#define PIN_ADC9  	PINB
#define ADC9_IDX  	6

#define DDR_INT0  	DDRB
#define PORT_INT0 	PORTB
#define PIN_INT0  	PINB
#define INT0_IDX  	6

#define DDR_T0  	DDRB
#define PORT_T0 	PORTB
#define PIN_T0  	PINB
#define T0_IDX  	6

#define DDR_PCINT14  	DDRB
#define PORT_PCINT14 	PORTB
#define PIN_PCINT14  	PINB
#define PCINT14_IDX  	6

#define DDR_ADC10  	DDRB
#define PORT_ADC10 	PORTB
#define PIN_ADC10  	PINB
#define ADC10_IDX  	7

#define DDR_PCINT15  	DDRB
#define PORT_PCINT15 	PORTB
#define PIN_PCINT15  	PINB
#define PCINT15_IDX  	7

